
#include "msg_util.h"
#include "structures/types.h"
#include "parser/debug.h"
#include "parser/global.h"
#include "parser/red.h"
#include "queues/msg_structures.h"

int reply_to_error(Tmensaje *msg) {

	Tmensaje the_reply;
	
	// Filling the message fields 
	strncpy(the_reply.performative, "not-understood", 14);
	strcpy(the_reply.sender, msg->receiver);
	
	if ( strcmp(msg->reply_to, "\0") == 0 )
		strcpy(the_reply.receiver, msg->sender);
	else strcpy(the_reply.receiver, msg->reply_to);
		
	strcpy(the_reply.conversation_id, msg->conversation_id);
	if (  strcmp(msg->reply_with, "\0") != 0 )
		strcpy(the_reply.in_reply_to, msg->reply_with);
	
	// By default the priority is copied
	strcpy(the_reply.x_priority, msg->x_priority);
	
	// And is sent
	return enviar(the_reply);
	
}
