#ifndef DEBUG_H
#define DEBUG_H


#include <stdio.h>
#include <string.h>
#include "../structures/types.h"

#define TAM_DEBUG 10240
#define TAM_DEBUG_LOG 10240

// Moved to debug.c
//#ifdef DEBUG
//static linkedlist debug_log;
//#endif

/// Prepare program for debugging
void debug_start();

/// Register a debug message
///
/// Insert a message into the debug log
/// @param msg Message to insert
/// @param code Debug code associated to the message
void debug_print(char *msg, int code);

/// Print out debug log
///
/// Print on the screen the full debug log
void debug_show_log();


#endif
