#include "../global.h"
#include "../debug.h"

//Invierte la cadena s
void reverse(char s[]){
  int c,i,j;

  for(i=0,j=strlen(s)-1;i<j;i++,j--){
    c=s[i];
    s[i]=s[j];
    s[j]=c;
  }
}


//Convierte un entero en una cadena de caracteres
void itoa(int n,char s[]){
  int i,sign;

  if((sign=n)<0) //Registra el signo
    n=-n;//Vuelve a n positivo

  i=0;

  do{ /*genera digitos en orden inverso*/
    s[i++]=n%10+'0'; //Toma el siguiente digito
  }while ((n=n/10)>0); //borralo
  
  if (sign<0)
    s[i++]='-';

  reverse(s);

  s[i]='\0';

}

long summarize(char *data) {
	int i;
	long sum = 0;
	
	for ( i = 0 ; i<strlen(data) ; i++ ) {
		sum += (int)data[i];
	}
	
	return sum;
}

int summarize_chunk(unsigned char *partdata) {
	int i;
	int sum = 0;
	
	for ( i = 0 ; i < CHUNK_SIZE ; i++ ) {
		sum += (int)partdata[i];
	}
	
	return sum;
}
