#include "utilleria.h"
#include "../debug.h"
#include "../global.h"

extern void reverse(char s[]);

/*
//Invierte la cadena s

void reverse(char s[]){
  int c,i,j;

  for(i=0,j=strlen(s)-1;i<j;i++,j--){
    c=s[i];
    s[i]=s[j];
    s[j]=c;
  }
}



//Convierte un entero en una cadena de caracteres
void itoa(int n,char s[]){
  int i,sign;

  if((sign=n)<0) //Registra el signo
    n=-n;//Vuelve a n positivo

  i=0;

  do{ //genera digitos en orden inverso
    s[i++]=n%10+'0'; //Toma el siguiente digito
  }while ((n=n/10)>0); //borralo
  
  if (sign<0)
    s[i++]='-';

  reverse(s);

  s[i]='\0';

}
*/

//Convierte un long en una cadena de caracteres
void ltoa(long n,char s[]){
  int i,sign;

  //printf("\nEl numerito es %li",n);
  if((sign=n)<0) //Registra el signo
    n=-n;//Vuelve a n positivo

  i=0;

  do{ /*genera digitos en orden inverso*/ 
    s[i++]=n%10+'0'; //Toma el siguiente digito
  }while ((n=n/10)>0); //borralo
  
  if (sign<0)
    s[i++]='-';

  reverse(s);

 
  s[i]='\0';

 //printf("La cadena en la funcion es: %s",s);

}



//Funcion q devuelve un puntero a un archivo q sera el archivo de Log
// Sino existe lo crea la primera vez q se llama la funcion y a partir de ahi siempre usa el mismo
FILE *  fichero_log(){
  time_t fecha;
  static  FILE * fichero;

  //Miramos si el archivo esta abierto, en caso contrario lo abrimos
  if (fichero==NULL){
    //Abrimos el fichero
    if((fichero = fopen("robot_log","w+"))==NULL){
      fprintf(stderr,"\nError al abrir el archivo");
      return stderr;
    }
  }
  fecha=time(NULL);
  fprintf(fichero,"\n\n\n%s\t",ctime(&fecha));
  return fichero;
}
