#ifndef _DECL_4_0_H_
#define _DECL_4_0_H_



#ifndef MODULE
#include "est_datos.h"


n_mks *n_mks_actual; 
/*=NULL;*/ 
			 /*** Pointer to the agent of a list being managed in
                          *    a moment.
                          *   It's initialized by "agent *first( l_agents *la)"
                          *    and actualized by "agent *next(), and more "
                          ***/


/*** KSI NODE LIST ***/
Lks l_ks;

float system_gain;

int mks_n;

systime_t init_deadline;
int Is_init_deadline;

l_allocat sched;

systime_t time_left;

hole *l_hole;


l_mks    tsa,
         ctsa,
         rsa,
         sub_rsa;
/*** Agendas ***/

/*** Global and permanent periodic agents list. ***/
l_mks periodic_mks_l;
l_mks non_periodic_mks_l;
n_in_agent *l_in_agent;

n_regla *v_reglas[8]; 

int first_call;   /*** It's used by CONTROL_KS in order not to activate
		   *   those agents without associated events every time
		   *   that function is called in one main_control call.
		   ***/
//extern n_event *EntryEvents, *LastEvent;


#endif

/***************************************************************************/


/***
 *
 *     This data should be defined at the KDM Level as Meta - Slots
 *
 ***/

int heuristic;
     /***
      *   This should be called SLS - Second Level Scheduler current policy
      ***/

float system_quality ;   /*** IT WOULDN'T HAVE TO BE A FLOAT ***/

/***
 *         ThreeC: 20010718
 ***/

int nExecIS;     /*** Number of times the IS has been executed ***/

float MaxQuality; 

int ReactivityDegree;   /*** [0..100] ***/
/*** --> scheduler.c (cuando se puedan adelantar las partes finales) ***/

int EventRate; /*** Max. number of events treated in a control cycle ***/

int LevelsCompleted; 
    /*** Number of levels completed with the current scheduling policy ***/

int LevelsInterrupted;
    /*** Number of levels interrupted with the current scheduling policy ***/

int LevelsKilled;
    /*** Number of levels killed with the current scheduling policy ***/

/*** More Meta - Slots needed: CurrentAttentionFocus ***/

#endif

