
/*

   FILE:
	artis_app.h

   Copyright (C) 1998-2003
        GTI-IA, DSIC, UPV


  This is free software;  you can  redistribute it  and/or modify it under
  terms of the  GNU General Public License as published  by the Free Soft-
  ware  Foundation;  either version 2,  or (at your option) any later ver-
  sion.  It is distributed in the hope that it will be useful, but WITH-
  OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
  for  more details.  You should have  received  a copy of the GNU General
  Public License;  see file COPYING.  If not, write to  the Free Software
  Foundation,  59 Temple Place - Suite 330,  Boston, MA 02111-1307, USA.

*/

/*

  AUTHOR(S): A. Terrasa

  CREATION DATE: 2003-10-16

  CHANGELOG:


  DESCRIPTION:
  
  Global include for all the ARTIS services exported to the
  application (main.c and rtl_tasks.c) but NOT to the user.

  In other words, all these module export functions to the two
  application main files (main.c and rtl_tasks.c), which need to be
  compiled for each application but are NOT edited by the user.

*/


//#include "../kdm/include/kdm.h"
#include "mutex.h"
//#include "meta_rule.h"
#include "time.h"

#ifdef MODULE
#include "rserver.h"
#else
#include "dserver.h"
#include "init.h"
#endif
