#include <artis/include/dserver.h>
#include <artis/dserver/include/dserver/em.h>
#include <artis/dserver/include/dserver/agenda.h>
void CreateStructures()
{
  in_agent *nu_inagent;
  mks *nu_mks;
  ks *nu_ks;

  nu_inagent=create_in_agent("producer", 1, 2);
  l_in_agent=insert_in_agent(nu_inagent, l_in_agent);

    nu_mks=create_mks("empty_mks", 1, "Critical", "RP", 0, 1, nu_inagent);
    insert_mks( &periodic_mks_l, nu_mks);
    in_mks_at_in_agent(nu_inagent, nu_mks);

	nu_ks=create_ks("empty_ks", 0, 100000, 0.000000);
	insert_ks(nu_ks, nu_mks);

    nu_mks=create_mks("empty_mks", 1, "Critical", "RP", 0, 1, nu_inagent);
    insert_mks( &periodic_mks_l, nu_mks);
    in_mks_at_in_agent(nu_inagent, nu_mks);

	nu_ks=create_ks("empty_ks", 0, 100000, 0.000000);
	insert_ks(nu_ks, nu_mks);

  nu_inagent=create_in_agent("consumer", 2, 2);
  l_in_agent=insert_in_agent(nu_inagent, l_in_agent);

    nu_mks=create_mks("empty_mks", 1, "Critical", "RP", 0, 1, nu_inagent);
    insert_mks( &periodic_mks_l, nu_mks);
    in_mks_at_in_agent(nu_inagent, nu_mks);

	nu_ks=create_ks("empty_ks", 0, 100000, 0.000000);
	insert_ks(nu_ks, nu_mks);

    nu_mks=create_mks("empty_mks", 1, "Critical", "RP", 0, 1, nu_inagent);
    insert_mks( &periodic_mks_l, nu_mks);
    in_mks_at_in_agent(nu_inagent, nu_mks);

	nu_ks=create_ks("empty_ks", 0, 100000, 0.000000);
	insert_ks(nu_ks, nu_mks);

}
