#include <stdio.h>

#include <artis/include/init.h>
#include <artis/include/dserver.h>

#include <artis/include/metaclass.h>

#include "userclass.h"
#include "optional_list.h"

#include "metavalue.h"
#include "attention_focus_definition.h" 
extern void CreateStructures();


int main(int argc,char * argv[]) {

	linux_artis_init();

	user_kdm_load();

	meta_kdm_load();

	if (AttentionFocusInit() < 0) {
	  return -1;
	}
printf("Finalizada la creación de los focos\n");
	
	CreateStructures();
printf("Finalizada la creación de las estructuras\n");

	fill_optional_levels();
printf("Finalizada la creación de los niveles\n");

	DS_start();

	empty_optional_levels();

	return 0;
	
}
