#include <artis/include/dserver.h>
#include <artis/include/em.h>
#include <artis/include/agenda.h>
void CreateStructures()
{
  inagent *nu_inagent;
  mks *nu_mks;
  ks *nu_ks;

  nu_inagent=create_in_agent("In_Agent_A", 1, 4);
  l_in_agent=insert_in_agent(nu_inagent, l_in_agent);

    nu_mks=create_mks("A_read_value", 1, "Critical", "RP", 1, 1, in_agent);
    insert_mks( &periodic_mks_l, nu_mks);
    in_mks_at_in_agent(in_agent, nu_mks);

	nu_ks=create_ks("calculate_B3", 3, 250, 0.000000);
	insert_ks(nu_ks, nu_mks);

    nu_mks=create_mks("B_read_value", 2, "Critical", "RP", 0, 1, in_agent);
    insert_mks( &periodic_mks_l, nu_mks);
    in_mks_at_in_agent(in_agent, nu_mks);

	nu_ks=create_ks("calculate_C0", 1, 120, 0.000000);
	insert_ks(nu_ks, nu_mks);

    nu_mks=create_mks("A_calculate_value", 4, "Critical", "RP", 1, 5:, in_agent);
    insert_mks( &periodic_mks_l, nu_mks);
    in_mks_at_in_agent(in_agent, nu_mks);

	nu_ks=create_ks("calculate_C0", 1, 120, 0.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("calculate_C1", 0, 150, -0.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("calculate_C0", 1, 120, 2.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("", 2, 120, -0.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("calculate_B3", 3, 250, -0.000000);
	insert_ks(nu_ks, nu_mks);

    nu_mks=create_mks("B_calculate_value", 5, "Critical", "RP", 1, 5:, in_agent);
    insert_mks( &periodic_mks_l, nu_mks);
    in_mks_at_in_agent(in_agent, nu_mks);

	nu_ks=create_ks("calculate_C0", 1, 120, 0.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("calculate_C1", 0, 150, -0.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("calculate_C0", 1, 120, 2.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("", 2, 120, -0.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("calculate_B3", 3, 250, -0.000000);
	insert_ks(nu_ks, nu_mks);

  nu_inagent=create_in_agent("In_Agent_C", 3, 4);
  l_in_agent=insert_in_agent(nu_inagent, l_in_agent);

    nu_mks=create_mks("C_calculate_value", 3, "Critical", "RP", 1, 5, in_agent);
    insert_mks( &periodic_mks_l, nu_mks);
    in_mks_at_in_agent(in_agent, nu_mks);

	nu_ks=create_ks("", 2, 120, 0.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("calculate_C1", 0, 150, -0.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("calculate_C0", 1, 120, 2.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("", 2, 120, -0.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("calculate_B3", 3, 250, -0.000000);
	insert_ks(nu_ks, nu_mks);

    nu_mks=create_mks("B_read_value", 2, "Critical", "RP", 0, 1, in_agent);
    insert_mks( &periodic_mks_l, nu_mks);
    in_mks_at_in_agent(in_agent, nu_mks);

	nu_ks=create_ks("calculate_C0", 1, 120, 0.000000);
	insert_ks(nu_ks, nu_mks);

    nu_mks=create_mks("C_read_value", 6, "Critical", "RP", 0, 1:, in_agent);
    insert_mks( &periodic_mks_l, nu_mks);
    in_mks_at_in_agent(in_agent, nu_mks);

	nu_ks=create_ks("calculate_C1", 0, 150, 0.000000);
	insert_ks(nu_ks, nu_mks);

    nu_mks=create_mks("B_calculate_value", 5, "Critical", "RP", 1, 5:, in_agent);
    insert_mks( &periodic_mks_l, nu_mks);
    in_mks_at_in_agent(in_agent, nu_mks);

	nu_ks=create_ks("calculate_C0", 1, 120, 0.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("calculate_C1", 0, 150, -0.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("calculate_C0", 1, 120, 2.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("", 2, 120, -0.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("calculate_B3", 3, 250, -0.000000);
	insert_ks(nu_ks, nu_mks);

  nu_inagent=create_in_agent("In_Agent_B", 2, 4);
  l_in_agent=insert_in_agent(nu_inagent, l_in_agent);

    nu_mks=create_mks("B_read_value", 2, "Critical", "RP", 0, 1, in_agent);
    insert_mks( &periodic_mks_l, nu_mks);
    in_mks_at_in_agent(in_agent, nu_mks);

	nu_ks=create_ks("calculate_C0", 1, 120, 0.000000);
	insert_ks(nu_ks, nu_mks);

    nu_mks=create_mks("C_calculate_value", 3, "Critical", "RP", 1, 5, in_agent);
    insert_mks( &periodic_mks_l, nu_mks);
    in_mks_at_in_agent(in_agent, nu_mks);

	nu_ks=create_ks("", 2, 120, 0.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("calculate_C1", 0, 150, -0.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("calculate_C0", 1, 120, 2.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("", 2, 120, -0.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("calculate_B3", 3, 250, -0.000000);
	insert_ks(nu_ks, nu_mks);

    nu_mks=create_mks("C_calculate_value", 3, "Critical", "RP", 1, 5:, in_agent);
    insert_mks( &periodic_mks_l, nu_mks);
    in_mks_at_in_agent(in_agent, nu_mks);

	nu_ks=create_ks("", 2, 120, 0.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("calculate_C1", 0, 150, -0.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("calculate_C0", 1, 120, 2.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("", 2, 120, -0.000000);
	insert_ks(nu_ks, nu_mks);

	nu_ks=create_ks("calculate_B3", 3, 250, -0.000000);
	insert_ks(nu_ks, nu_mks);

    nu_mks=create_mks("C_read_value", 6, "Critical", "RP", 0, 1:, in_agent);
    insert_mks( &periodic_mks_l, nu_mks);
    in_mks_at_in_agent(in_agent, nu_mks);

	nu_ks=create_ks("calculate_C1", 0, 150, 0.000000);
	insert_ks(nu_ks, nu_mks);

}
