/*!
  \file globals.h
  \date Time-stamp: <20-03-2005 15:47>
  \author M. Rebollo
  \version 0.1
  
  \brief Global data heafer file for the parser of the KDM

  It includes several global definitios for all the kdmparser.
*/

#ifndef _GLOBALS_H_
#define _GLOBALS_H_

/*! 
  \fn    printf_verbose(s)
  \var   s string wih the message to print
  \brief Prints 's' on stdout if the user has defined verbose mode
*/ 
#define printf_verbose(s,args...) if( verbose_mode ) printf(s,##args)

/*!
  \var   int verbose_mode
  \brief Allows the user define a verbose or a silent mode
         0: silent mode, 1: verbose mode
*/ 
extern int verbose_mode;

#endif

