import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.lang.*;
import java.io.*;
import java.util.*;
import com.jgraph.JGraph;
import com.jgraph.graph.*;
import javax.swing.tree.*;
import javax.swing.border.*;
import java.lang.Object.*;

import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;




public class Ks 
{
	
	
	String nombre;
	String id;
	int wcet;
	//si existe el codefile no existe el source y viceversa.
	String codefile;
	String source;
	DefaultPort puerto;
	DefaultGraphCell cuadro;
	String directorioActual;
	
	int valido;

	
	
	public Ks()
	{
		

		
		
	} //termina el metodo Ks
	
		public void GuardarKs(FileWriter salida)
	{
		
		try {
			
	  	salida.write("<ks id=\""+id+"\">"+"\n");
	  	salida.write("<codefile lang = \"c\">"+codefile+"</codefile>"+"\n");
	  	salida.write("<name>"+nombre+"</name>"+"\n");
	  	salida.write("<wcet ud=\"ns\">"+wcet+"</wcet>"+"\n");
	  	salida.write("</ks>");

		       } catch (Exception e) {
            System.err.println("Error al escribir: "+e.getMessage());
        	   e.printStackTrace();
        }
		
	} //termina el metodo guardarKs
	
	public void cargarKs(Element childElement) {
	
		id = childElement.getAttribute("id");
		//System.err.println("id es "+id);

			
						NodeList hijosks = childElement.getChildNodes();
						for (int j=0; j < hijosks.getLength(); j++)
						{
							Node hijo = hijosks.item(j);
							if (hijo instanceof Element)
							{
								Element elementohijo = (Element)hijo;
								//System.err.println("Este hijo-interior es "+elementohijo.getTagName());
								Text textNode = (Text)elementohijo.getFirstChild();
								String text = textNode.getData().trim();
								if (elementohijo.getTagName().equals("name")){
									nombre=text;
									//System.err.println("nombre es "+nombre);

								}
								else if (elementohijo.getTagName().equals("wcet")){
									
									wcet=Integer.parseInt(text);
									//System.err.println("wcet es "+wcet);
																		
								}
								else if (elementohijo.getTagName().equals("codefile")) {
									codefile=text;
									//System.err.println("codefile "+codefile);
																		
								}
	
							}
						}
		

		
	}//termina el metodo cargarKS
	
	
	public void newks(Frame frame, final Agente ag,final DefaultMutableTreeNode nodo, final DefaultTreeModel model, final int hijos, final JTree arbolProyectos, final String directorio) {
		
		
		final Frame fa = frame;
		
		final JDialog dialog = new JDialog(frame, " Add a new Ks", true);
		final JTextField eNombre;
		
		eNombre = new JTextField();
		
		Container contentPane = dialog.getContentPane();
		
		dialog.setBounds(frame.getLocationOnScreen().x+100,frame.getLocationOnScreen().y+100,300,150);
		
		JPanel panelbotones = new JPanel();
		JButton bAceptar = new JButton(" Accept ");
		JButton bCancel = new JButton(" Cancel ");
		
		bAceptar.setRequestFocusEnabled(false);
		bAceptar.addActionListener( new ActionListener() {
			    public void actionPerformed(ActionEvent e) {
			    	 	nombre=eNombre.getText();
			    	 	//valido=1;   
							if (eNombre.getText().length()==0) {
                  Mensaje nuevo = new Mensaje(fa,"Error","Name invalid");
                return;				        	
							}
							
							if (eNombre.getText().equals("Entities") || eNombre.getText().equals("Ontology") || eNombre.getText().equals("Control") || eNombre.getText().equals("In-agents") || eNombre.getText().equals("Behavior") || eNombre.getText().equals("MKS") || eNombre.getText().equals("KS") || eNombre.getText().equals("Classes") || eNombre.getText().equals("Instances") || eNombre.getText().equals("Focus") || eNombre.getText().equals("Rules") || eNombre.getText().equals("Project") ){
                                                            Mensaje nuevo = new Mensaje(fa,"Error","Name invalid");
								//MensajeImagen nuevo = new MensajeImagen(fa,"Error","Name invalid","peligro");
								return;
							}

							Enumeration a = ag.ks.elements();
							int cont = 0;
							while (a.hasMoreElements()) {
								Ks kasas = (Ks) a.nextElement();
								cont++;
								if (kasas.nombre.equals(nombre)) {
									Mensaje nuevo = new Mensaje (fa, "Error", "Repeated name");
									return;
								}
							}
							cont++;
							
							id = Integer.toString(cont); 
							//System.err.println(id);
							
							
    		  		DefaultMutableTreeNode nuevo = new DefaultMutableTreeNode(nombre);
    		  		model.insertNodeInto(nuevo,nodo,hijos);
    		  		TreeNode[] nodes = model.getPathToRoot(nuevo);
    		  		TreePath path = new TreePath(nodes);
    		  		arbolProyectos.scrollPathToVisible(path);
                                
                                
                                String nombrefichero;
                                nombrefichero = nombre+".c";
                                codefile = nombrefichero;
                                try {
                                    FileWriter guardamos = new FileWriter(new File(directorio,nombrefichero));
                                    String linea = new String();
                                    guardamos.write("void "+nombre+"(void) {"+"\n");
                                    guardamos.write("\n");
                                    guardamos.write("}");
                                    guardamos.close();
                                    /*
                                     *			
                                        FileWriter salida = new FileWriter(new File(directorio,"entidades.xml"));
                                        String linea = new String();
                                        salida.write("<?xml version =\"1.0\" encoding= \"UTF-8\" ?>"+"\n");
                                        String nom;
                                        String ides;
                                        agent.GuardarAgente(salida);
                                        salida.close();
                                    */
                                } catch (Exception ex) {
                                    System.err.println("Error al escribir: "+ex.getMessage());
                                    ex.printStackTrace();
                                }
									
							dialog.dispose();
				}});

        bCancel.setRequestFocusEnabled(false);
			  bCancel.addActionListener( new ActionListener() {
			    public void actionPerformed(ActionEvent e) {
			    	  dialog.dispose();
				}});

    panelbotones.add(bAceptar);
    panelbotones.add(bCancel);   
    panelbotones.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
    
    eNombre.setColumns(20);
    JPanel panelnom = new JPanel();
    panelnom.setBorder (BorderFactory.createTitledBorder("Name"));
    panelnom.add(eNombre);
    
    contentPane.add(panelnom, BorderLayout.CENTER);
    contentPane.add(panelbotones, BorderLayout.SOUTH);
    
    dialog.show();
		
	}//cerrar el metodo newks
	
		public Ks Buscaks (String nombreb, Agente ag){
		
		Enumeration a = ag.ks.elements();
		int validar;
		validar = 0;
		Ks bes;
		Ks encontrado = new Ks();
		
		
		while (a.hasMoreElements()) {
			bes = (Ks) a.nextElement();
			if (nombreb.equals(bes.nombre)) {
				validar=1;
				encontrado=bes;
			}
		}
		
		if (validar==0) {
			return null;
		} else {
			return encontrado;
		}
		
	}//cierra el metodo Buscaks
	
	
	public void editarpropertiesks2 (final Frame frame, String compra,final Interfaz inter) {
		
				
		final Frame fa = frame;
		
		final JDialog dialog = new JDialog(frame, " Edit properties : KS "+compra, true);
		final JTextField eNombre;
		
		eNombre = new JTextField();
		eNombre.setText(compra);
		
		valido =0;
		final String nombreoriginal = compra;
		
		final JTextField code;
		final JTextField wc;
		//final JTextField typ;
		//impor = new JTextField();
		code = new JTextField();
		wc = new JTextField();
		
		Container contentPane = dialog.getContentPane();
		
		dialog.setBounds(frame.getLocationOnScreen().x+100,frame.getLocationOnScreen().y+100,320,310);
		
		JPanel panelbotones = new JPanel();
		JButton bAceptar = new JButton(" Accept ");
		JButton bCancel = new JButton(" Cancel ");
		
		
		
		bAceptar.setRequestFocusEnabled(false);
		bAceptar.addActionListener( new ActionListener() {
			    public void actionPerformed(ActionEvent e) {
			    	 	nombre=eNombre.getText();
			    	 	
			    	 	if (nombreoriginal.equals(nombre)) {
			    	 		valido = 0;
			    	 	} else {
			    	 		valido = 1;	
			    	 	}
			    	 	//importancia=Integer.parseInt(impor.getText());
			    	 	//periodo=Integer.parseInt(peri.getText());
			    	 	
			    	 	//importancia=Integer.parseInt(text);
			    	 	//valido=1;   
							if (eNombre.getText().length()==0) {
                  Mensaje nuevo = new Mensaje(fa,"Error","Name invalid");
                return;				        	
							}
							
							if (eNombre.getText().equals("Entities") || eNombre.getText().equals("Ontology") || eNombre.getText().equals("Control") || eNombre.getText().equals("In-agents") || eNombre.getText().equals("Behavior") || eNombre.getText().equals("MKS") || eNombre.getText().equals("KS") || eNombre.getText().equals("Classes") || eNombre.getText().equals("Instances") || eNombre.getText().equals("Focus") || eNombre.getText().equals("Rules") || eNombre.getText().equals("Project") ){
                                                            Mensaje nuevo = new Mensaje(fa,"Error","Name invalid");
								//MensajeImagen nuevo = new MensajeImagen(fa,"Error","Name invalid","peligro");
								return;
							}
							
							if (wc.getText().length()>0) {
								wcet=Integer.parseInt(wc.getText());
							}
							
							if (code.getText().length()>0) {
								codefile=code.getText();
							}
							
							dialog.dispose();
				}});

        bCancel.setRequestFocusEnabled(false);
			  bCancel.addActionListener( new ActionListener() {
			    public void actionPerformed(ActionEvent e) {
			    	  dialog.dispose();
				}});

    panelbotones.add(bAceptar);
    panelbotones.add(bCancel);   
    panelbotones.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
    
    JPanel boton = new JPanel();
		JButton cfile = new JButton(" Create file ");
		JButton  exami = new JButton(" Examinar ");
		/*
    cfile.setRequestFocusEnabled(false);
	  cfile.addActionListener( new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
	    	  //dialog.dispose();
	    	try {
					Process process = null;
					process=Runtime.getRuntime().exec("C:/WINNT/NOTEPAD.exe C:/Documents and Settings/mcmoncho.PERSEFONE/Escritorio/mc.c");
					//process=Runtime.getRuntime().exec("C:/Documents and Settings/mcmoncho.PERSEFONE/Escritorio/mc.txt");
				}catch (IOException x) {
			
				}
		}});
		
		*/
		exami.setRequestFocusEnabled(false);
	  exami.addActionListener( new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
	    	  //dialog.dispose();
	    	//try {
	    	  //Interfaz inte = new Interfaz();
					String linea;
					String nomProy = inter.openFile("c");
				//}catch (FileNotFoundException g) {
					//System.err.println("Fichero" +g +" no encontrado");
			codefile=nomProy;
			code.setText(nomProy);
				//}
		}});
    
		
    JPanel panelcon = new JPanel();
    
    boton.add(cfile);
    boton.add(exami);
    
    JPanel contenedor = new JPanel();
    
    eNombre.setColumns(10);
    JPanel panelnom = new JPanel();
    panelnom.setBorder (BorderFactory.createTitledBorder("Name"));
    panelnom.add(eNombre);
    
    code.setColumns(25);
    JPanel panelperi = new JPanel();
    panelperi.setBorder (BorderFactory.createTitledBorder("Codefile"));
    panelperi.add(code);
    code.setText(codefile);

    wc.setColumns(10);
    JPanel paneldead = new JPanel();
    paneldead.setBorder (BorderFactory.createTitledBorder("Wcet"));
    paneldead.add(wc);
    
    panelcon.add(panelperi);
    panelcon.add(boton);

    //contenedor.add(panelimpor,BorderLayout.NORTH);
    contenedor.add(panelnom,BorderLayout.CENTER);
    contenedor.add(paneldead,BorderLayout.SOUTH);
    
    contentPane.add(contenedor, BorderLayout.NORTH);
    contentPane.add(panelcon,BorderLayout.CENTER);
    contentPane.add(panelbotones, BorderLayout.SOUTH);
    
    dialog.show();

		
	}//termina el metodo editarpropertiesin
        
        
        
        
        
        public void editarpropertiesks (final Frame frame, String compra,final Interfaz inter, final String directorio) {
		
				
		final Frame fa = frame;
		
		final JDialog dialog = new JDialog(frame, " Edit properties : KS "+compra, true);
		final JTextField eNombre;
		
		eNombre = new JTextField();
		eNombre.setText(compra);
		
		valido =0;
		final String nombreoriginal = compra;
		
		//final JTextField code;
		final JTextField wc;
		//final JTextField typ;
		//impor = new JTextField();
		//code = new JTextField();
		wc = new JTextField();
		
		Container contentPane = dialog.getContentPane();
		
		dialog.setBounds(frame.getLocationOnScreen().x+100,frame.getLocationOnScreen().y+100,320,200);
		
		JPanel panelbotones = new JPanel();
		JButton bAceptar = new JButton(" Accept ");
		JButton bCancel = new JButton(" Cancel ");
		
		
		
		bAceptar.setRequestFocusEnabled(false);
		bAceptar.addActionListener( new ActionListener() {
			    public void actionPerformed(ActionEvent e) {
			    	 	nombre=eNombre.getText();
			    	 	
			    	 	if (nombreoriginal.equals(nombre)) {
			    	 		valido = 0;
			    	 	} else {
			    	 		valido = 1;
                                                String nombreantiguo;
                                                nombreantiguo = nombreoriginal+".c";
                                                String nombrenuevo;
                                                nombrenuevo=nombre+".c";
                                                File file = new File(directorio,nombreantiguo);
                                                File file2 = new File(directorio,nombrenuevo);
                                                boolean sucess = file.renameTo(file2);
			    	 	}
			    	 	//importancia=Integer.parseInt(impor.getText());
			    	 	//periodo=Integer.parseInt(peri.getText());
			    	 	
			    	 	//importancia=Integer.parseInt(text);
			    	 	//valido=1;   
							if (eNombre.getText().length()==0) {
                  Mensaje nuevo = new Mensaje(fa,"Error","Invalid Name");
                return;				        	
							}
							
							if (eNombre.getText().equals("Entities") || eNombre.getText().equals("Ontology") || eNombre.getText().equals("Control") || eNombre.getText().equals("In-agents") || eNombre.getText().equals("Behavior") || eNombre.getText().equals("MKS") || eNombre.getText().equals("KS") || eNombre.getText().equals("Classes") || eNombre.getText().equals("Instances") || eNombre.getText().equals("Focus") || eNombre.getText().equals("Rules") || eNombre.getText().equals("Project") ){
                                                            Mensaje nuevo = new Mensaje(fa,"Error","Name invalid");
								//MensajeImagen nuevo = new MensajeImagen(fa,"Error","Name invalid","peligro");
								return;
							}
							
							if (wc.getText().length()>0) {
								wcet=Integer.parseInt(wc.getText());
							}
							String fichero;
                                                        fichero = nombre+".c";
							codefile = fichero;
							
							dialog.dispose();
				}});

        bCancel.setRequestFocusEnabled(false);
			  bCancel.addActionListener( new ActionListener() {
			    public void actionPerformed(ActionEvent e) {
			    	  dialog.dispose();
				}});

    panelbotones.add(bAceptar);
    panelbotones.add(bCancel);   
    panelbotones.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
    
    
    
		
    JPanel panelcon = new JPanel();
    JButton examinar = new JButton(" Edit File ");
    examinar.setRequestFocusEnabled(false);
    examinar.addActionListener( new ActionListener() {
        public void actionPerformed(ActionEvent e) {
    	  //dialog.dispose();
            String aux = codefile;
            String aux2 = directorio;
            String aux3 = aux2+"/"+aux;
            try {
		Process process = null;
		process=Runtime.getRuntime().exec("emacs "+ aux3);
		//process=Runtime.getRuntime().exec("C:/Documents and Settings/mcmoncho.PERSEFONE/Escritorio/mc.txt");
                //process=Runtime.getRuntime().exec("C:/WINDOWS/NOTEPAD.exe "+ aux3);
                //process=Runtime.getRuntime().exec("C:/WINDOWS/NOTEPAD.exe");
            }catch (IOException x) {
		System.err.println("IOException"+x);
                x.printStackTrace();
            }
            dialog.dispose();
    }});
    panelcon.add(examinar);
    
    JPanel contenedor = new JPanel();
    
    eNombre.setColumns(10);
    JPanel panelnom = new JPanel();
    panelnom.setBorder (BorderFactory.createTitledBorder("Name"));
    panelnom.add(eNombre);
    
    

    wc.setColumns(10);
    JPanel paneldead = new JPanel();
    paneldead.setBorder (BorderFactory.createTitledBorder("Wcet (ns)"));
    paneldead.add(wc);
    
    

    //contenedor.add(panelimpor,BorderLayout.NORTH);
    contenedor.add(panelnom,BorderLayout.CENTER);
    contenedor.add(paneldead,BorderLayout.SOUTH);
    
    contentPane.add(contenedor, BorderLayout.NORTH);
    contentPane.add(panelcon,BorderLayout.CENTER);
    contentPane.add(panelbotones, BorderLayout.SOUTH);
    
    dialog.show();

		
	}//termina el metodo editarpropertiesin
	
	

	

	
	
} //termina la clase Ks