/*
 * MetaClase.java
 *
 * Created on 28 de enero de 2005, 18:07
 */

/**
 *
 * @author  mcmoncho
 */


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.lang.*;
import java.io.*;
import java.util.*;
import com.jgraph.JGraph;
import com.jgraph.graph.*;
import javax.swing.tree.*;
import javax.swing.border.*;
import java.lang.Object.*;

import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;







public class MetaClase {
    
    String nombre;
    String maxQuality;
    String slsPolicy;
    String reactivityDegree;
    String eventRate;
    String nCurrentBehavior;
    String id;
    
    
    
    
    
    /** Creates a new instance of MetaClase */
    public MetaClase() {
    }
    
    public void newMC(Frame frame, final Control controlador,final DefaultMutableTreeNode nodo, final DefaultTreeModel model, final int hijos, final JTree arbolProyectos) {
		
		
		final Frame fa = frame;
		
		final JDialog dialog = new JDialog(frame, " New MetaClass", true);
		final JTextField eNombre;
		
		eNombre = new JTextField();
		
		Container contentPane = dialog.getContentPane();
		
		dialog.setBounds(frame.getLocationOnScreen().x+100,frame.getLocationOnScreen().y+100,300,150);
		
		JPanel panelbotones = new JPanel();
		JButton bAceptar = new JButton(" Accept ");
		JButton bCancel = new JButton(" Cancel ");
		
		bAceptar.setRequestFocusEnabled(false);
		bAceptar.addActionListener( new ActionListener() {
			    public void actionPerformed(ActionEvent e) {
			    	 	nombre=eNombre.getText();
			    	 	//valido=1;   
					if (eNombre.getText().length()==0) {
                                            Mensaje nuevo = new Mensaje(fa,"Error","Name invalid");
                                            return;				        	
					}
                                        Enumeration a = controlador.reglas.elements();
                                        int cont = 0;
                                        while (a.hasMoreElements()) {
                                                a.nextElement();
                                                cont++;
                                        }
                                        cont++;

                                        id = "mrule"+cont; 
                                        //System.err.println(id);
							
							
    		  		DefaultMutableTreeNode nuevo = new DefaultMutableTreeNode(nombre);
    		  		model.insertNodeInto(nuevo,nodo,hijos);
    		  		TreeNode[] nodes = model.getPathToRoot(nuevo);
    		  		TreePath path = new TreePath(nodes);
    		  		arbolProyectos.scrollPathToVisible(path);
									
				dialog.dispose();
				}});

        bCancel.setRequestFocusEnabled(false);
			  bCancel.addActionListener( new ActionListener() {
			    public void actionPerformed(ActionEvent e) {
			    	  dialog.dispose();
	}});

    panelbotones.add(bAceptar);
    panelbotones.add(bCancel);   
    panelbotones.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
    
    eNombre.setColumns(20);
    JPanel panelnom = new JPanel();
    panelnom.setBorder (BorderFactory.createTitledBorder("Name"));
    panelnom.add(eNombre);
    
    contentPane.add(panelnom, BorderLayout.CENTER);
    contentPane.add(panelbotones, BorderLayout.SOUTH);
    
    dialog.show();
		
    }//cerrar el metodo newMC
    
    
    
    
    
    public void editMC(Frame frame, String nom){
        
        final Frame fa = frame;
        final JDialog dialog = new JDialog(frame, "Metaclass",true);
        
        final JTextField eNombre;
        
        eNombre = new JTextField(); 
        eNombre.setText(nom);
        
        final JTextField maxima = new JTextField();
        final JTextField sls = new JTextField();
        final JTextField degree = new JTextField();
        final JTextField event = new JTextField();
        final JTextField ncurrent = new JTextField();
        
        //System.err.println("max"+maxQuality);
        if (maxQuality != null){
            
            maxima.setText(maxQuality);
        }
        if (slsPolicy != null){
            sls.setText(slsPolicy);
        }
        if (reactivityDegree != null){
            degree.setText(reactivityDegree);
        }
        if (eventRate != null){
            event.setText(eventRate);
        }
        if (nCurrentBehavior != null){
            ncurrent.setText(nCurrentBehavior);
        }
                
        Container contentPane = dialog.getContentPane();
        dialog.setBounds(frame.getLocationOnScreen().x+100,frame.getLocationOnScreen().y+100,300,500);
        
        JPanel grid = new JPanel();
        grid.setLayout(new GridLayout(5,1));
        
        
        maxima.setColumns(20);
        JPanel panelmaxima = new JPanel();
        panelmaxima.setBorder (BorderFactory.createTitledBorder("MaxQuality"));
        panelmaxima.add(maxima);
        
        sls.setColumns(20);
        JPanel panelsls = new JPanel();
        panelsls.setBorder (BorderFactory.createTitledBorder("SlsPolicy"));
        panelsls.add(sls);
        
        degree.setColumns(20);
        JPanel paneldegree = new JPanel();
        paneldegree.setBorder (BorderFactory.createTitledBorder("ReactivityDegree"));
        paneldegree.add(degree);
        
        event.setColumns(20);
        JPanel panelevent = new JPanel();
        panelevent.setBorder (BorderFactory.createTitledBorder("EventRate"));
        panelevent.add(event);
        
        ncurrent.setColumns(20);
        JPanel panelncurrent = new JPanel();
        panelncurrent.setBorder (BorderFactory.createTitledBorder("nCurrentBehavior"));
        panelncurrent.add(ncurrent);
        
    
        grid.add(panelmaxima);
        grid.add(panelsls);
        grid.add(paneldegree);
        grid.add(panelevent);
        grid.add(panelncurrent);
               
        
        
        JPanel panelbotones = new JPanel();
        JButton aceptar = new JButton(" Accept ");
        JButton cancelar = new JButton(" Cancel ");
        
        aceptar.setRequestFocusEnabled(false);
        aceptar.addActionListener(new ActionListener() {        
        public void actionPerformed(ActionEvent e){
            
            //aqui empiezo
            if (eNombre.getText().length()==0) {
                    Mensaje nuevo = new Mensaje(fa,"Error","Name invalid");
                    return;				        	
            }
            
            if (eNombre.getText().equals("Entities") || eNombre.getText().equals("Ontology") || eNombre.getText().equals("Control") || eNombre.getText().equals("In-agents") || eNombre.getText().equals("Behavior") || eNombre.getText().equals("MKS") || eNombre.getText().equals("KS") || eNombre.getText().equals("Classes") || eNombre.getText().equals("Instances") || eNombre.getText().equals("Focus") || eNombre.getText().equals("Rules") || eNombre.getText().equals("Project") ){
                Mensaje nuevo = new Mensaje(fa,"Error","Name invalid");
			//MensajeImagen nuevo = new MensajeImagen(fa,"Error","Name invalid","peligro");
			return;
            }
            
            nombre=eNombre.getText();
            
            if (maxima.getText().length()==0) {
                    Mensaje nuevo = new Mensaje(fa,"Error","Invalid maxQuality value");
                    return;				        	
            }
            String aux = maxima.getText();
            int max = Integer.parseInt(aux);
            if (max > 100){
                Mensaje nuevo = new Mensaje(fa,"Error"," maxQuality must be less than 100 ");
                return;
            }
            System.err.println("escribo"+aux);
            maxQuality = aux;
            
            if (sls.getText().length()==0) {
                    Mensaje nuevo = new Mensaje(fa,"Error","Invalid slsPolicy value");
                    return;				        	
            }
            aux = sls.getText();
            max = Integer.parseInt(aux);
            if (max > 100){
                Mensaje nuevo = new Mensaje(fa,"Error"," slsPolicy must be less than 100 ");
                return;
            }
            slsPolicy = aux;
            
            if (degree.getText().length()==0) {
                    Mensaje nuevo = new Mensaje(fa,"Error","Invalid reactivityDegree value");
                    return;				        	
            }
            aux = degree.getText();
            max = Integer.parseInt(aux);
            if (max > 100){
                Mensaje nuevo = new Mensaje(fa,"Error"," reactivityDegree must be less than 100 ");
                return;
            }
            reactivityDegree = aux;
            
            if (event.getText().length()==0) {
                    Mensaje nuevo = new Mensaje(fa,"Error","Invalid eventRate value");
                    return;				        	
            }
            aux = event.getText();
            max = Integer.parseInt(aux);
            if (max > 100){
                Mensaje nuevo = new Mensaje(fa,"Error"," eventRate must be less than 100 ");
                return;
            }
            eventRate = aux;
            
            if (ncurrent.getText().length()==0) {
                    Mensaje nuevo = new Mensaje(fa,"Error","Invalid nCurrentBehavior value");
                    return;				        	
            }
            aux = ncurrent.getText();
            max = Integer.parseInt(aux);
            if (max > 100){
                Mensaje nuevo = new Mensaje(fa,"Error"," nCurrentBehavior must be less than 100 ");
                return;
            }
            nCurrentBehavior = aux;
            
            
            
            
        
            dialog.dispose();
        
            
        }});
        
        
        cancelar.setRequestFocusEnabled(false);
        cancelar.addActionListener(new ActionListener() {        
        public void actionPerformed(ActionEvent e){
            
            dialog.dispose();
            
        }});
        
        panelbotones.add(aceptar);
        panelbotones.add(cancelar);
        panelbotones.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
        
        
        eNombre.setColumns(20);
        JPanel panelnom = new JPanel();
        panelnom.setBorder (BorderFactory.createTitledBorder("Name"));
        panelnom.add(eNombre);
        
        contentPane.add(panelnom, BorderLayout.NORTH);
        contentPane.add(grid, BorderLayout.CENTER);
        contentPane.add(panelbotones, BorderLayout.SOUTH);
        
        dialog.show();

                       
    }//cierra el metodo editMC
    
    
    
    
    public void Guardar(FileWriter salida){
	  
	  try {
	  	
	  	//System.err.println("ebtri aju");
	  	
		salida.write("<MetaClass>"+"\n");
                salida.write("<name>"+nombre+"</name>"+"\n");
                salida.write("<maxQuality>"+maxQuality+"</maxQuality>"+"\n");
                salida.write("<slsPolicy>"+slsPolicy+"</slsPolicy>"+"\n");
                salida.write("<reactivityDegree>"+reactivityDegree+"</reactivityDegree>"+"\n");
                salida.write("<eventRate>"+eventRate+"</eventRate>"+"\n");
                salida.write("<nCurrentBehavior>"+nCurrentBehavior+"</nCurrentBehavior>"+"\n");
                salida.write("</MetaClass>"+"\n");	
	  
	  } catch (Exception e) {
            System.err.println("Error al escribir: "+e.getMessage());
        	   e.printStackTrace();
          }
	  	


		
		
    } //termina el metodo guardar
    
    public void Cargar(NodeList children) {
	
	
		for (int i=0; i < children.getLength(); i++)
		{
			
			Node child = children.item(i);
			if (child instanceof Element)
			{
				
				Element childElement = (Element)child;
			 
				Text textNode = (Text)childElement.getFirstChild();
				String text = textNode.getData().trim();
	
				
				if (childElement.getTagName().equals("name"))
					{
						nombre = text;
                                                
					}
					
				else if (childElement.getTagName().equals("maxQuality")) {
						maxQuality = text;
                                              
						
						
				}//	
				else if (childElement.getTagName().equals("slsPolicy")) {
						slsPolicy= text;
						
						
				}//
				else if (childElement.getTagName().equals("reactivityDegree")) {
						reactivityDegree= text;
						
						
				}//
				else if (childElement.getTagName().equals("eventRate")) {
						eventRate= text;
						
						
				}//
                                else if (childElement.getTagName().equals("nCurrentBehavior")) {
						nCurrentBehavior= text;
						
						
				}//
				
			}
		}

		
				
	
}//termina el metodo Cargar	
    
    	public MetaClase BuscaMetaclase (String nombreb, Control con){
		
		Enumeration a = con.mclases.elements();
		int validar;
		validar = 0;
		MetaClase bes;
		MetaClase encontrado = new MetaClase();
		
		while (a.hasMoreElements()) {
			bes = (MetaClase) a.nextElement();
			if (nombreb.equals(bes.nombre)) {
				validar=1;
				encontrado=bes;
			}
		}
		
		if (validar==0) {
			return null;
		} else {
			return encontrado;
		}
		
	}//cierra el metodo BuscaMetaclase
    
    
    
}//cierra la clase MetaClase
