
#include "parser/mensaje/mensaje.h"

/// Builds and sends a reply to an error
///
/// Builds a SIMBA message of the "NOT UNDERSTOOD" kind
/// in reply to an erroneous message and sends it without
/// going through the normal outbox.
/// This function is designed to work as a transparent
/// mechanism to the communication.
/// @param msg Erroneous message to reply
/// @return Error if there is one
int reply_to_error(Tmensaje *msg);
