
#ifndef GLOBAL_H
#define GLOBAL_H

#define TAM_MSG 10240
#define MAX_ROBOTS 2
#define TAM_DIRECCION_IP 50


#ifndef FALSE
/// Logic value for FALSE
#define FALSE 0
#endif
#ifndef TRUE
/// Logic value for TRUE
#define TRUE 1
#endif

/// Message chunk size
#define CHUNK_SIZE 20  // Bytes


/// For the transport level
#define MSG_MAX_SIZE 1024

/// Chunk from a message to be sent via network 
typedef struct _chunk {
	int index;
	int total;
	int sum;
	unsigned char data[CHUNK_SIZE];
} chunk;

#endif
