#ifndef TRANSPORTE_UTILLERIA_H
#define TRANSPORTE_UTILLERIA_H

#include <string.h>
#include "../global.h"

/// Invierte una cadena
/// @param s La cadena
void reverse(char s[]);

/// Convierte un entero en una cadena de caracteres
/// @param n El entero
/// @param s Cadena a rellenar
void itoa(int n,char s[]);

/// Devuelve un numero resumen de una cadena de texto
/// @param data La cadena a resumir
/// @return Numero resumen
long summarize(char *data);

int summarize_chunk(char *partdata);

#endif

