#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "./mensaje/mensaje.h"
#include <stdio.h>
#include "./nivel_transporte/transporte.h"
#include "debug.h"
#include "red.h"

#define TAMLINEA 255 //N de caracteres maximo que puede tener linea
#define TAMMSG	 10240
/*Programa para probar la funcion q trocea un mensaje
Entradas: archivo
Salida: Imprime la estructura del mensaje
*/

//extern int extraer_campos_mensaje(char msg[], Tmensaje * campos_mensaje);

FILE * fd;

int nueva_entrada;
char linea[TAMLINEA];
char mensaje[TAMMSG];
Tmensaje campos;

int main(int argc,char * argv[]){
  printf("\nComenzando a ejecutar...\n");
	if ( (argc!=2) && (argc!=3) ) {
		printf("\nEl uso es: comando fichero [-d]\n");
		fflush(stdout);
		exit(1);
	}
	

 if((fd=fopen(argv[1],"r+"))==NULL){
 	perror("\nError abriendo archivo");
	exit(1);
 }

 while ((fgets(linea,TAMLINEA,fd))!=NULL){
	strcat(mensaje,linea);
 }

 //debug_print("Cadena:",0);
 //debug_print(mensaje,0);
 extraer_campos_mensaje(mensaje, & campos);

 debug_print("VAMOS A PROCEDER CON EL ENVIO DEL MENSAJE",0);
 // imprimir_campos_mensaje(campos);
 
 enviar(campos);

 debug_print("MENSAJE SUPUESTAMENTE ENVIADO POR LA RED", 0);
 
 /*printf("\n\n El mensaje es %s",mensaje);

 extraer_campos_mensaje(mensaje,&campos);
 imprimir_campos_mensaje(campos);
 */ 
 
 if ((argc==3) && (strcmp("-d", argv[2])==0) )
  	debug_show_log();
 
 return 0;
}
