
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "../time/include/time.h"
#include "parser/red.h"
#include "include/como.h"


#define TAMLINEA 255 
#define TAMMSG	 10240

int read_msg_from_file(char *arg1, char *mensaje) {
	FILE * fd;
	char linea[TAMLINEA];
		
	if((fd=fopen(arg1,"r+"))==NULL){
 		printf("\nError opening file\n\n");
		return -1;
 	}

	while ((fgets(linea,TAMLINEA,fd))!=NULL){
		strcat(mensaje,linea);
 	}
	
	return 0;
}


int main(int argc, char *argv[]) {
	char msg[TAMMSG];
    systime_t tiempo, tiempo2, total, max = 0;
	int i, iter = 0;
	FILE *f;
	
	como_init();
    systime_init();
		
	
	read_msg_from_file("lleno.txt", msg);
	
	/*f = fopen("/dev/random", "r");
	fread(msg, sizeof(char), TAMMSG, f);
	fclose(f);*/
	
	//printf("El mensaje es\n");
	//printf("%s\n\n", msg);
	
	printf("Starting measures . . .\n");
	
	for ( i = 0 ; i<10000 ; i++) {
		tiempo = systime_gettime();
		como_send(msg, "TEST");
		tiempo2 = systime_gettime();
		total = tiempo2 - tiempo;
		printf("%d: Send time %lli nanosecs\n", i, total);
		if (total > max) {
			max = total;
			iter = i;
		}		
	}
	
	printf("\nMax: %lli nanosecs in iteration %i\n", max, iter);
	    

	return 0;
}
