/*!
  \file events.c
  \date Time-stamp: <16-11-2004 00:44>
  \author M. Rebollo <mrebollo@dsic.upv.es>
  \version 0.2

  \brief internal access funtions to event management
*/


#include <assert.h>
#include <stdlib.h>
#include "../include/kdm/events.h"
#include "../include/kdm/static.h"



//---------------------------------------------------
// inline functions
//--------------------------------------------------- 

inline int 
kdm_event_add( void* slot, int event, int imp ){
 ((static_slot*)slot)->event |= event;
 ((static_slot*)slot)->imp = imp;
 return 0;
} //kdm_event_add()


inline int 
kdm_event_release( void* slot, int event ){
  ((static_slot*)slot)->event &= ~event; //Complemento a uno de event
  return 0;
} //kdm_event_release()


inline int 
kdm_event_set( void* slot, int event, int imp ){
 ((static_slot*)slot)->event = event;
 ((static_slot*)slot)->imp = imp;
 return 0;
} //kdm_event_set()


