#include <stdio.h>
#include <artis/linux_core/include/linux_core.h>
#include <artis/include/dserver.h>
#include <artis/include/kdm.h>
#include "userclass.h"

#include <artis/include/mutex.h>
#include "KS/world_ks.c"

void rtfunc(void *dummy){}
void optional_level_2(void *dummy)
{
  world_ks();
}


void fill_optional_levels(void) 
{
  if (Level_Create(0, rtfunc, NULL) != LINUX_CORE_SUCCESS)
	DS_stop(1);
  if (Level_Create(1, optional_level_2, NULL) != LINUX_CORE_SUCCESS)
	DS_stop(1);
}


void empty_optional_levels(void) 
{
  if (Level_Destroy(0) != LINUX_CORE_SUCCESS)
	fprintf(stderr, "(empty_optional_levels) Error destroying level\n");
  if (Level_Destroy(1) != LINUX_CORE_SUCCESS)
	fprintf(stderr, "(empty_optional_levels) Error destroying level\n");
}
