import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.lang.*;
import java.io.*;
import java.util.*;
import com.jgraph.JGraph;
import com.jgraph.graph.*;
import javax.swing.tree.*;
import javax.swing.border.*;
import java.lang.Object.*;

import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;



public class Behavior 
{
	
	
	String nombre;
	String id;
	Vector inagent;
	int valido;
	DefaultPort puerto;
	DefaultGraphCell cuadro;
	

	
	
	public Behavior()
	{
		

		inagent = new Vector();
		
	} //termina el metodo behavior
	
	public void newBehavior(Frame frame, final Agente ag,final DefaultMutableTreeNode nodo, final DefaultTreeModel model, final int hijos, final JTree arbolProyectos) {
			
	
		
		final Frame fa = frame;
		
		final JDialog dialog = new JDialog(frame, " Add a new Behavior", true);
		final JTextField eNombre;
		
		eNombre = new JTextField();
		
		Container contentPane = dialog.getContentPane();
		
		dialog.setBounds(frame.getLocationOnScreen().x+100,frame.getLocationOnScreen().y+100,300,150);
		
		JPanel panelbotones = new JPanel();
		JButton bAceptar = new JButton(" Accept ");
		JButton bCancel = new JButton(" Cancel ");
		
		bAceptar.setRequestFocusEnabled(false);
		bAceptar.addActionListener( new ActionListener() {
			    public void actionPerformed(ActionEvent e) {
			    	  nombre=eNombre.getText();
			    	 	//valido=1;   
				if (eNombre.getText().length()==0) {
                                  Mensaje nuevo = new Mensaje(fa,"Error","Name invalid");
				//MensajeImagen nuevo = new MensajeImagen(fa,"Error","Name invalid","peligro");
                                return;				        	
				}
							
							if (eNombre.getText().equals("Entities") || eNombre.getText().equals("Ontology") || eNombre.getText().equals("Control") || eNombre.getText().equals("In-agents") || eNombre.getText().equals("Behavior") || eNombre.getText().equals("MKS") || eNombre.getText().equals("KS") || eNombre.getText().equals("Classes") || eNombre.getText().equals("Instances") || eNombre.getText().equals("Focus") || eNombre.getText().equals("Rules") || eNombre.getText().equals("Project") ){
                                                                Mensaje nuevo = new Mensaje(fa,"Error","Name invalid");
								//MensajeImagen nuevo = new MensajeImagen(fa,"Error","Name invalid","peligro");
								return;
							} 
							
							Enumeration a = ag.behavior.elements();
							int cont = 0;
							while (a.hasMoreElements()) {
								Behavior bes = (Behavior) a.nextElement();
								cont++;
								if (bes.nombre.equals(nombre)) {
									Mensaje nuevo = new Mensaje (fa, "Error", "Repeated name");
									return;
								}
							}
							cont++;
							
							id = Integer.toString(cont); 
							//System.err.println (id);
							
							
    		  		DefaultMutableTreeNode nuevo = new DefaultMutableTreeNode(nombre);
    		  		model.insertNodeInto(nuevo,nodo,hijos);
    		  		TreeNode[] nodes = model.getPathToRoot(nuevo);
    		  		TreePath path = new TreePath(nodes);
    		  		arbolProyectos.scrollPathToVisible(path);
									
							dialog.dispose();
				}});

        bCancel.setRequestFocusEnabled(false);
			  bCancel.addActionListener( new ActionListener() {
			    public void actionPerformed(ActionEvent e) {
			    	  dialog.dispose();
				}});

    panelbotones.add(bAceptar);
    panelbotones.add(bCancel);   
    panelbotones.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
    
    eNombre.setColumns(20);
    JPanel panelnom = new JPanel();
    panelnom.setBorder (BorderFactory.createTitledBorder("Name"));
    panelnom.add(eNombre);
    
    contentPane.add(panelnom, BorderLayout.CENTER);
    contentPane.add(panelbotones, BorderLayout.SOUTH);
    
    dialog.show();
		
	}//cerrar el metodo AadirBehavior
	
    public void GuardarBehavior(FileWriter salida) {
	

		try {
			
	  	salida.write("<behavior id=\""+id+"\">"+"\n");
	  	salida.write("<name>"+nombre+"</name>"+"\n");
	  	salida.write("<in-agents>"+"\n");
	  	
	  	Enumeration in = inagent.elements();
	  	Inagent ina;
	  	while (in.hasMoreElements()) {
	  		//System.err.println("heidi y el abuelo");
	  		ina = (Inagent) in.nextElement();
	  		//System.err.println("esto es ina"+ina);
	  		
	  		salida.write("<element type =\"in-agent\" id=\""+ina.nombre+"\"/>"+"\n");
	  	}
	  	//System.err.println("heidi,pedro y el abuelo");
	  	salida.write("</in-agents>");
	  	salida.write("\n");
	  	salida.write("</behavior>");
	  	salida.write("\n");
	  	
	  	
	  	       } catch (Exception e) {
                        System.err.println("Error al escribir: "+e.getMessage());
                        e.printStackTrace();
        }
        
	  	


		
		
	} //termina el metodo guardarbehavior
    
    
    
        public void GuardarBehavior2(FileWriter salida) {
	

		try {
			
	  	salida.write("<behavior id=\""+id+"\">"+"\n");
	  	salida.write("<name>"+nombre+"</name>"+"\n");
	  	salida.write("<in-agents>"+"\n");
	  	
	  	Enumeration in = inagent.elements();
	  	Inagent ina;
	  	while (in.hasMoreElements()) {
	  		//System.err.println("heidi y el abuelo");
	  		ina = (Inagent) in.nextElement();
	  		//System.err.println("esto es ina"+ina);
	  		
	  		salida.write("<element type =\"in-agent\" id=\""+ina.id+"\"/>"+"\n");
	  	}
	  	//System.err.println("heidi,pedro y el abuelo");
	  	salida.write("</in-agents>");
	  	salida.write("\n");
	  	salida.write("</behavior>");
	  	salida.write("\n");
	  	
	  	
	  	       } catch (Exception e) {
                        System.err.println("Error al escribir: "+e.getMessage());
                        e.printStackTrace();
        }
        
	  	


		
		
	} //termina el metodo guardarbehavior
	
	
	public void cargarBehavior(Element childElement) {
	
			//System.err.println("tenemos atributos id = "+childElement.getAttribute("id"));
			
			id = childElement.getAttribute("id");
			//System.err.println("id es "+id);

			
						NodeList hijosbehavior = childElement.getChildNodes();
						for (int j=0; j < hijosbehavior.getLength(); j++)
						{
							Node hijo = hijosbehavior.item(j);
							if (hijo instanceof Element)
							{
								Element elementohijo = (Element)hijo;
								//System.err.println("Este hijo-interior es "+elementohijo.getTagName());
								Text textNode = (Text)elementohijo.getFirstChild();
								String text = textNode.getData().trim();
								if (elementohijo.getTagName().equals("name")){
									nombre=text;
									//System.err.println("nombre es "+nombre);

								}
								else if (elementohijo.getTagName().equals("in-agents")){
									
									NodeList vectorinagents = elementohijo.getChildNodes();
									for (int i=0; i < vectorinagents.getLength(); i++)
									{
										Node hijoinagent = vectorinagents.item(i);
										if (hijoinagent instanceof Element)
										{
											Element hijoina = (Element)hijoinagent;
											//System.err.println("Este re-hijo-interior es "+hijoina.getTagName());
											Text nododetexto = (Text) hijoina.getFirstChild();
											//System.err.println("Este 111");
											
											//System.err.println("222");
											if (hijoina.getTagName().equals("element")){
											String unodelosinagents;
											unodelosinagents = hijoina.getAttribute("type");
											//System.err.println(unodelosinagents);
											String unodelosinagents2;
											unodelosinagents2 = hijoina.getAttribute("id");
											//System.err.println("portatil "+unodelosinagents2);
											Inagent ina = new Inagent();//
											ina.nombre=unodelosinagents2;//
											//inagent.add(unodelosinagents2);
											inagent.add(ina);
											}
										}
									}
								}
							}
						}
						

		
	}//termina el metodo cargarBehavior
	
	//public void editarpropertiesbh (Frame frame, String compra, final DefaultMutableTreeNode nodo, final DefaultTreeModel model, final int hijos, final JTree arbolProyectos,final JTabbedPane solapa) {
		public void editarpropertiesbh (Frame frame, String compra, final DefaultMutableTreeNode nodo, final DefaultTreeModel model, final int hijos, final JTree arbolProyectos) {
		
			
		
		final Frame fa = frame;
		
		final JDialog dialog = new JDialog(frame, " Edit Behavior", true);
		final JTextField eNombre;
		
		eNombre = new JTextField();
		
		valido = 0;
		final String nom1;
		nom1= compra;
		
		eNombre.setText(compra);
		
		Container contentPane = dialog.getContentPane();
		
		dialog.setBounds(frame.getLocationOnScreen().x+100,frame.getLocationOnScreen().y+100,300,150);
		
		JPanel panelbotones = new JPanel();
		JButton bAceptar = new JButton(" Accept ");
		JButton bCancel = new JButton(" Cancel ");
		
		bAceptar.setRequestFocusEnabled(false);
		bAceptar.addActionListener( new ActionListener() {
			    public void actionPerformed(ActionEvent e) {
			    	 	nombre=eNombre.getText();
			    	 	if (nombre.equals(nom1)){
			    	 		valido=0;
			    	 	} else {
			    	 		valido=1;	
			    	 	}
			    	 	   
							if (eNombre.getText().length()==0) {
                  Mensaje nuevo = new Mensaje(fa,"Error","Name invalid");
                return;				        	
							}
							
							if (eNombre.getText().equals("Entities") || eNombre.getText().equals("Ontology") || eNombre.getText().equals("Control") || eNombre.getText().equals("In-agents") || eNombre.getText().equals("Behavior") || eNombre.getText().equals("MKS") || eNombre.getText().equals("KS") || eNombre.getText().equals("Classes") || eNombre.getText().equals("Instances") || eNombre.getText().equals("Focus") || eNombre.getText().equals("Rules") || eNombre.getText().equals("Project") ){
                                                            Mensaje nuevo = new Mensaje(fa,"Error","Name invalid");
								//MensajeImagen nuevo = new MensajeImagen(fa,"Error","Name invalid","peligro");
								return;
							}
							
    		  		DefaultMutableTreeNode nuevo = new DefaultMutableTreeNode(nombre);
    		  		model.insertNodeInto(nuevo,nodo,hijos);
    		  		TreeNode[] nodes = model.getPathToRoot(nuevo);
    		  		TreePath path = new TreePath(nodes);
    		  		arbolProyectos.scrollPathToVisible(path);
								
														
							
							dialog.dispose();
				}});

        bCancel.setRequestFocusEnabled(false);
			  bCancel.addActionListener( new ActionListener() {
			    public void actionPerformed(ActionEvent e) {
			    	  dialog.dispose();
				}});

    panelbotones.add(bAceptar);
    panelbotones.add(bCancel);   
    panelbotones.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
    
    eNombre.setColumns(20);
    JPanel panelnom = new JPanel();
    panelnom.setBorder (BorderFactory.createTitledBorder("Name"));
    panelnom.add(eNombre);
    
    contentPane.add(panelnom, BorderLayout.CENTER);
    contentPane.add(panelbotones, BorderLayout.SOUTH);
    
    dialog.show();

		
	}//termina el metodo editarpropertiesbh
	
	public Behavior BuscaBehavior (String nombreb, Agente ag){
		
		Enumeration a = ag.behavior.elements();
		int validar;
		validar = 0;
		Behavior bes;
		Behavior encontrado = new Behavior();
		
		while (a.hasMoreElements()) {
			bes = (Behavior) a.nextElement();
			if (nombreb.equals(bes.nombre)) {
				validar=1;
				encontrado=bes;
			}
		}
		
		if (validar==0) {
			return null;
		} else {
			return encontrado;
		}
		
	}//cierra el metodo BuscaBehavior
	
	
} //termina la clase Behavior