import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.lang.*;
import java.io.*;
import java.util.*;
import com.jgraph.JGraph;
import com.jgraph.graph.*;
import javax.swing.tree.*;
import javax.swing.border.*;
import java.lang.Object.*;

import javax.xml.parsers.*;
import org.w3c.dom.*;
import org.xml.sax.*;




public class Regla 
{
	
	
	String nombre;
	String id;
	String numero;
	String tipo;
	Even eventu;
	//Algunos tipos de reglas pueden tener asociados un slot que se especificara abajo;

	String slot;
	Vector condition;
	Vector action;
        
        int valido;
        JTable table;
        JTable table2;
        int contador;
        
        String clase;
        String instancia;
        String slote;



	
	
	public Regla()
	{
		condition = new Vector();
		action = new Vector();	
                eventu = new Even();
		
	} //termina el metodo Regla
	
	public void GuardarRegla(FileWriter salida)
	{
	
		try {
				
	  	salida.write("<mrule id=\""+id+"\">"+"\n");
	  	salida.write("<name>"+nombre+"</name>"+"\n");
	  	salida.write("<number>"+numero+"</number>"+"\n");
	  	eventu.GuardarEven(salida);
	  	salida.write("<condition>"+"\n");
	  	//salida.write("<and>"+"\n");
	  	Enumeration ru = condition.elements();
	  	//Atomo atomica;
	  	String condi;
	  	while (ru.hasMoreElements()) {
	  		condi = (String) ru.nextElement();
	  		salida.write("<atom>"+condi+"</atom>"+"\n");
	  		//atomica.GuardarAtomo(salida);
	  	}
	  	 
	  	//salida.write("</and>"+"\n");
	  	salida.write("</condition>"+"\n");
	  	salida.write("<action>"+"\n");
	  	Enumeration rus = action.elements();
	  	String acti;
	  	while (rus.hasMoreElements()) {
	  		acti = (String) rus.nextElement();
	  		salida.write("<atom>"+acti+"</atom>"+"\n");
	  	}

	  	salida.write("</action>"+"\n");
	  	salida.write("</mrule>"+"\n");

		 
            
   } catch (Exception e) {
            System.err.println("Error al escribir: "+e.getMessage());
        	   e.printStackTrace();
   }	
	  	

	
	}  //termina el metodo GuardarRegla
	
	public void cargarRegla(Element childElement) {
		
		//System.err.println("soy yo");
		id = childElement.getAttribute("id");
		//System.err.println("id es "+id);

			
		NodeList hijosbehavior = childElement.getChildNodes();
		for (int j=0; j < hijosbehavior.getLength(); j++)
		{
			Node hijo = hijosbehavior.item(j);
			if (hijo instanceof Element)
			{
				Element elementohijo = (Element)hijo;
				//System.err.println("Este hijo-interior es "+elementohijo.getTagName());
				Text textNode = (Text)elementohijo.getFirstChild();
				String text = textNode.getData().trim();
				if (elementohijo.getTagName().equals("name")){
					nombre=text;
					//System.err.println("nombre es "+nombre);

				}
				else if (elementohijo.getTagName().equals("number")){
					//numero=Integer.parseInt(text);
                                        numero = text;
					//System.err.println("numero es "+numero);
					
				}//
				else if (elementohijo.getTagName().equals("event")){
					
					Even eventual = new Even();
					eventual.slote = text;
					eventual.tipo = elementohijo.getAttribute("type");
                                        String aux = text;
                                        int fin = aux.length(); 
                                        int primerpunto = aux.indexOf('.');
                                        String cc = aux.substring(0,primerpunto);
                                        int segundopunto = aux.indexOf('.', primerpunto+1);
                                        String ii = aux.substring(primerpunto+1,segundopunto);
                                        String ss = aux.substring(segundopunto+1,fin);
                                        clase = cc;
                                        instancia = ii;
                                        slote = ss;
                                        
					eventu = eventual;
					//System.err.println("even "+text);
					
				}//

				else if (elementohijo.getTagName().equals("condition")){
					//System.err.println("paso por condition");
					NodeList vectorinagents = elementohijo.getChildNodes();
					for (int i=0; i < vectorinagents.getLength(); i++)
					{
						Node hijoinagent = vectorinagents.item(i);
						if (hijoinagent instanceof Element)
						{
							Element hijoina = (Element)hijoinagent;
							//System.err.println("Y por aki");
							Text nododetexto = (Text) hijoina.getFirstChild();
							String texteamos = nododetexto.getData().trim();
							
							if (hijoina.getTagName().equals("atom")) {
                                                            condition.add(texteamos);
                                                            /*
								
								//System.err.println ("dentro de un and");
								NodeList listadenodos = hijoina.getChildNodes();
								for (int x=0; x < listadenodos.getLength();x++)
								{
									Node inodo = listadenodos.item(x);
									if (inodo instanceof Element) {
										Element nodo =(Element)inodo;
										Text nodtex = (Text) nodo.getFirstChild();
										String testeo = nodtex.getData().trim();
										
										if (nodo.getTagName().equals("atom")) {
											Atomo atom = new Atomo();
											atom.negativo = false;
											atom.id=testeo;
											//System.err.println(testeo);
											condition.add(atom);
										}
										else if (nodo.getTagName().equals("not")) {
											
											NodeList lista = nodo.getChildNodes();
												for (int y=0; y < lista.getLength();y++)
												{
													Node nonode = lista.item(y);
													if (nonode instanceof Element) {
														Element nodoe =(Element)nonode;
														Text texnodtex = (Text) nodoe.getFirstChild();
														String itesteo = texnodtex.getData().trim();
														if (nodoe.getTagName().equals("atom")) {
															Atomo tomo = new Atomo();
															tomo.negativo = true;
															tomo.id = itesteo;
															//System.err.println(itesteo);
															condition.add(tomo);
														}
													}
												}                         
                         
                                                                                }//else if not
                                                                        }//if
								}//for  int x = 0
                                                                */
							} // if and 
	
						} //if
					}	//for 				
				}//

				else if (elementohijo.getTagName().equals("action")){
					//System.err.println ("entro en action");
					
					NodeList ina = elementohijo.getChildNodes();
					for (int b=0; b < ina.getLength(); b++)
					{
						Node hijoi = ina.item(b);
						if (hijoi instanceof Element)
						{
							Element hijoin = (Element)hijoi;
							Text nodos = (Text) hijoin.getFirstChild();
							String itoi = nodos.getData().trim();

							if (hijoin.getTagName().equals("atom")){
							
								action.add(itoi);			
							
							}
						}
					}
					
				}// else if action
			}
		}
	}//termina el metodo cargarRegla
	
	public void newregla(Frame frame, final Control controlador,final DefaultMutableTreeNode nodo, final DefaultTreeModel model, final int hijos, final JTree arbolProyectos) {
		
		
		final Frame fa = frame;
		
		final JDialog dialog = new JDialog(frame, " Add a new Rule", true);
		final JTextField eNombre;
		
		eNombre = new JTextField();
		
		Container contentPane = dialog.getContentPane();
		
		dialog.setBounds(frame.getLocationOnScreen().x+100,frame.getLocationOnScreen().y+100,300,150);
		
		JPanel panelbotones = new JPanel();
		JButton bAceptar = new JButton(" Accept ");
		JButton bCancel = new JButton(" Cancel ");
		
		bAceptar.setRequestFocusEnabled(false);
		bAceptar.addActionListener( new ActionListener() {
			    public void actionPerformed(ActionEvent e) {
			    	 	nombre=eNombre.getText();
			    	 	//valido=1;   
					if (eNombre.getText().length()==0) {
                                                Mensaje nuevo = new Mensaje(fa,"Error","Name invalid");
                                                return;				        	
                                        }
                                        Enumeration a = controlador.reglas.elements();
                                        int cont = 0;
                                        while (a.hasMoreElements()) {
                                                a.nextElement();
                                                cont++;
                                        }
                                        cont++;

                                        id = nombre; 
                                        //System.err.println(id);
							
							
    		  		DefaultMutableTreeNode nuevo = new DefaultMutableTreeNode(nombre);
    		  		model.insertNodeInto(nuevo,nodo,hijos);
    		  		TreeNode[] nodes = model.getPathToRoot(nuevo);
    		  		TreePath path = new TreePath(nodes);
    		  		arbolProyectos.scrollPathToVisible(path);
									
							dialog.dispose();
				}});

        bCancel.setRequestFocusEnabled(false);
			  bCancel.addActionListener( new ActionListener() {
			    public void actionPerformed(ActionEvent e) {
			    	  dialog.dispose();
	}});

    panelbotones.add(bAceptar);
    panelbotones.add(bCancel);   
    panelbotones.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
    
    eNombre.setColumns(20);
    JPanel panelnom = new JPanel();
    panelnom.setBorder (BorderFactory.createTitledBorder("Name"));
    panelnom.add(eNombre);
    
    contentPane.add(panelnom, BorderLayout.CENTER);
    contentPane.add(panelbotones, BorderLayout.SOUTH);
    
    dialog.show();
		
	}//cerrar el metodo newregla
        
        
     /*   
    public void editregla(Frame frame, final String compra, final Control controlador, final Ontologia Onto) {
		
		contador=0;
		final Frame fa = frame;
		
		final JDialog dialog = new JDialog(frame, " Edit Rule", true);
		final JTextField eNombre;
		
		eNombre = new JTextField();
                eNombre.setText(compra);
                final JTextField impor = new JTextField();
		JTextField seleccion = new JTextField();
                final JComboBox eventoclase = new JComboBox();
                final JComboBox tip2 = new JComboBox();
                
                valido = 0;
                final String nombreoriginal;
                nombreoriginal= compra;
                
		Container contentPane = dialog.getContentPane();
		
		dialog.setBounds(frame.getLocationOnScreen().x+100,frame.getLocationOnScreen().y+100,700,700);

                               
		JPanel panelbotones = new JPanel();
		JButton bAceptar = new JButton(" Accept ");
		JButton bCancel = new JButton(" Cancel ");
		
		bAceptar.setRequestFocusEnabled(false);
		bAceptar.addActionListener( new ActionListener() {
			    public void actionPerformed(ActionEvent e) {
                                 nombre=eNombre.getText();
                                 if (nombreoriginal.equals(nombre)) {
                                    valido = 0;
                                 }else {
                                    valido = 1;
                                 }
			    	 	//valido=1;   
                                    if (eNombre.getText().length()==0) {
                                        Mensaje nuevo = new Mensaje(fa,"Error","Name invalid");
                                        return;				        	
                                    }
                                    if (impor.getText().length()==0) {
                                        numero = "0";                                        				        	
                                    }else {
                                        numero = impor.getText();
                                    }
                                    String aux = (String) tip2.getSelectedItem();
                                    if (aux.equals("CON_PERIOD")){
                                        
                                    }else {
                                        
                                    }
                                    
                                         /*
                                        Enumeration a = controlador.atfocus.elements();
                                        int cont = 0;
                                        while (a.hasMoreElements()) {
                                                a.nextElement();
                                                cont++;
                                        }
                                        cont++;

                                        id = "at"+cont; 
                                        System.err.println(id);
							
							
    		  		DefaultMutableTreeNode nuevo = new DefaultMutableTreeNode(nombre);
    		  		model.insertNodeInto(nuevo,nodo,hijos);
    		  		TreeNode[] nodes = model.getPathToRoot(nuevo);
    		  		TreePath path = new TreePath(nodes);
    		  		arbolProyectos.scrollPathToVisible(path);
      
				//Aqui iba un cierra comentario
      					
				dialog.dispose();
				}});

        bCancel.setRequestFocusEnabled(false);
	bCancel.addActionListener( new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                dialog.dispose();
	}});

    panelbotones.add(bAceptar);
    panelbotones.add(bCancel);   
    panelbotones.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
    
       
    eNombre.setColumns(20);
    JPanel panelnom = new JPanel();
    panelnom.setBorder (BorderFactory.createTitledBorder("Name"));
    panelnom.add(eNombre);
    
    
    impor.setColumns(5);
    JPanel panelimpor = new JPanel();
    panelimpor.setBorder (BorderFactory.createTitledBorder("Importance"));
    panelimpor.add(impor);
    
    JPanel grid1 = new JPanel();
    grid1.setLayout(new GridLayout(1,2));
    grid1.add(panelnom);
    grid1.add(panelimpor);
    
    
    //COMIENZA EVENTO
    
    //JLabel tip = new JLabel("Type");
    
    tip2.addItem("MODIFICATION");
    tip2.addItem("CON_PERIOD");
    tip2.addItem("DELETION");
    tip2.addItem("NEW_PRED");
    tip2.addItem("MATCHED_PRED");
    tip2.addItem("UNMATCHED_PRED");

    JButton btipo = new JButton ( "Ok");
    /*
    btipo.setRequestFocusEnabled(false);
    btipo.addActionListener(new ActionListener(){
        public void actionPerformed (ActionEvent e){
            System.err.println("oso");
            String aux;
            aux = (String) tip2.getSelectedItem();
            System.err.println("oso11");
            if (aux.equals("CON_PERIOD")){
                System.err.println("oso1");
                eventoclase.removeAllItems();
                System.err.println("oso2");
            } else {
                System.err.println("oso3");
                eventoclase.removeAllItems();
                System.err.println("oso4");
                Enumeration enu = Onto.clases.elements();
                System.err.println("oso5");
                Clase cl;
                String nomb;
                while (enu.hasMoreElements()){
                    cl = (Clase) enu.nextElement();
                    nomb= cl.nombre;
                    eventoclase.addItem(nomb);
                }
            }

    }});
     Aqui iba otro cierra comentario
    
    
    
    JPanel eventoarriba = new JPanel();
    eventoarriba.setBorder(BorderFactory.createTitledBorder("Type"));
    eventoarriba.add(tip2);
    eventoarriba.add(btipo);
 
    
    
    
    //El panel con la seleccion final
    seleccion.setColumns(20);
    JPanel panelseleccion = new JPanel();
    panelseleccion.setBorder (BorderFactory.createTitledBorder("Class_Instance_Slot"));
    panelseleccion.add(seleccion);
    
    //El panel que lleva Slot.slot
    JButton beventoslo = new JButton ( "Ok");
    beventoslo.setRequestFocusEnabled(false);
    beventoslo.addActionListener(new ActionListener(){
        public void actionPerformed (ActionEvent e){

    }});
    final JComboBox eventoslo = new JComboBox();
    JPanel peventoslo = new JPanel();
    peventoslo.setBorder(BorderFactory.createTitledBorder("Slot"));
    peventoslo.add(eventoslo);
    //peventoslo.add(beventoslo);
        
    
    //El panel que lleva Slot.instancia
    final JComboBox eventoins = new JComboBox();
    eventoins.addActionListener(new ActionListener(){
        public void actionPerformed (ActionEvent e){
       
            String cl = (String) eventoins.getSelectedItem();
            Instancia aux = new Instancia();
            Instancia encontrada = aux.BuscaInstancia(cl,Onto);
            String cla = encontrada.clase;
            Clase aux2 = new Clase();
            Clase encon=aux2.BuscaClase(cla, Onto);
            
            Enumeration en = encon.slots.elements();
            Slot slo = new Slot();
            String sloname;
                while (en.hasMoreElements()){
                    slo = (Slot) en.nextElement();
                    sloname= slo.nombre;
                    eventoslo.addItem(sloname);
                }
            
        }
    });
    JButton beventoins = new JButton ( "Ok");
    beventoins.setRequestFocusEnabled(false);
    beventoins.addActionListener(new ActionListener(){
        public void actionPerformed (ActionEvent e){

            String cl = (String) eventoins.getSelectedItem();
            Instancia aux = new Instancia();
            Instancia encontrada = aux.BuscaInstancia(cl,Onto);
            String cla = encontrada.clase;
            Clase aux2 = new Clase();
            Clase encon=aux2.BuscaClase(cla, Onto);
            
            Enumeration en = encon.slots.elements();
            Slot slo = new Slot();
            String sloname;
                while (en.hasMoreElements()){
                    slo = (Slot) en.nextElement();
                    sloname= slo.nombre;
                    eventoslo.addItem(sloname);
                }
            
            
    }});
    
    JPanel peventoins = new JPanel();
    peventoins.setBorder(BorderFactory.createTitledBorder("Instances"));
    peventoins.add(eventoins);
    //peventoins.add(beventoins);
    
       
    //El panel que lleva Slot.clase
    JButton beventoclase = new JButton ( "Ok");
    beventoclase.setRequestFocusEnabled(false);
    beventoclase.addActionListener(new ActionListener(){
        public void actionPerformed (ActionEvent e){
            System.err.println("entro");
            String cl = (String) eventoclase.getSelectedItem();
            Clase aux = new Clase();
            Clase encontrada = aux.BuscaClase(cl,Onto);
            Enumeration en = encontrada.instancias.elements();
            int talla = encontrada.instancias.size();
            System.err.println(talla);
            Instancia ina = new Instancia();
            String intaname;
                while (en.hasMoreElements()){
                    ina = (Instancia) en.nextElement();
                    intaname= ina.nombre;
                    eventoins.addItem(intaname);
                }
            
            
            
    }});
    //JComboBox eventoclase = new JComboBox();
    Enumeration enu = Onto.clases.elements();
    Clase cl;
    String nomb;
    while (enu.hasMoreElements()){
        cl = (Clase) enu.nextElement();
        nomb= cl.nombre;
        eventoclase.addItem(nomb);
    }
    
    eventoclase.addActionListener(new ActionListener(){
       public void actionPerformed (ActionEvent e){
           
            String cl = (String) eventoclase.getSelectedItem();
            Clase aux = new Clase();
            Clase encontrada = aux.BuscaClase(cl,Onto);
            Enumeration en = encontrada.instancias.elements();
            int talla = encontrada.instancias.size();
            System.err.println(talla);
            Instancia ina = new Instancia();
            String intaname;
                while (en.hasMoreElements()){
                    ina = (Instancia) en.nextElement();
                    intaname= ina.nombre;
                    eventoins.addItem(intaname);
                }
           
       }
    });
    JPanel peventoclase = new JPanel();
    peventoclase.setBorder(BorderFactory.createTitledBorder("Class"));
    peventoclase.add(eventoclase);
   // peventoclase.add(beventoclase);
    
    
    //El gridlayout dondo meto el tipo , y los slot de clase, instancia y slot
    /*
    JPanel gridevent = new JPanel();
    gridevent.setLayout(new GridLayout(5,1));
    gridevent.add(eventoarriba);
    gridevent.add(peventoclase);
    gridevent.add(peventoins);
    gridevent.add(peventoslo);
    gridevent.add(panelseleccion);
    //Aqui iba otro cierra comentario
    JPanel vacio = new JPanel();
    JPanel vacio2 = new JPanel();
    JPanel gridevent = new JPanel();
    gridevent.setLayout(new GridLayout(2,3));
    gridevent.add(eventoarriba);
    gridevent.add(vacio);
    gridevent.add(vacio2);
    gridevent.add(peventoclase);
    gridevent.add(peventoins);
    gridevent.add(peventoslo);
    //gridevent.add(panelseleccion);
    
    //El gridlayout anterior todo rebordeado de la palabra evento
    JPanel panelevento = new JPanel();
    panelevento.setBorder(BorderFactory.createTitledBorder("Event"));
    panelevento.add(gridevent);
    
    //ACABA EVENTO
    
    
    //EMPIEZA CONDICION
    
    String[] columnNames = {" Conditions " };                        
    Object[][] data = {
                  
    		{""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""}
                   		
    };
    table = new JTable(data, columnNames);
           		    	
    JScrollPane scrollpane = new JScrollPane (table);
    table.setPreferredScrollableViewportSize ( new Dimension(350,120));
    table.setShowHorizontalLines(true);

    JPanel scroll = new JPanel();
    scroll.add(scrollpane);
 
    
    JPanel vacio3 = new JPanel();
    
    JPanel gridcondi = new JPanel();
    gridcondi.setLayout(new GridLayout(1,2));
    gridcondi.add(scroll);
    gridcondi.add(vacio3);
    JPanel panelcondicion = new JPanel();
    panelcondicion.setBorder(BorderFactory.createTitledBorder("Condition"));
    //panelcondicion.add(gridcondi);
    panelcondicion.add(scroll);
    
    //ACABA CONDICION
    
    
    //EMPIEZA ACCION
        
    String[] columnNames2 = {" Actions " };                        
    Object[][] data2 = {
                  
    		{""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""}
                   		
    };
    table2 = new JTable(data2, columnNames2);
           		    	
    JScrollPane scrollpane2 = new JScrollPane (table2);
    table2.setPreferredScrollableViewportSize ( new Dimension(350,120));
    table2.setShowHorizontalLines(true);

    final JPanel scroll2 = new JPanel();
    scroll2.add(scrollpane2);
    
    final JComboBox acciones = new JComboBox();
    acciones.addItem("KDM_Set_Value");
    acciones.addItem("TriggerSporadicLevel");
    acciones.addItem("SetReactivityDegree");
    acciones.addItem("SetPolicy");
    acciones.addItem("SetFocus");
    acciones.addItem("SetAttentionDegree");
    acciones.addItem("SetBehavior");
    acciones.addItem("KDM_Add_Event");
    acciones.addItem("KDM_Release_Event");
    
    
    JButton baccion = new JButton ( "Add Action");
    baccion.setRequestFocusEnabled(false);
    baccion.addActionListener(new ActionListener(){
        public void actionPerformed (ActionEvent e){
            //table2.SetValueAt("a",contador,0);
            
            String auxi;
            auxi = (String) acciones.getSelectedItem();
            action.add(auxi);
            int colum= 0;
            table2.setValueAt(auxi,contador,colum);
            contador=contador+1;
            
            //scroll2.removeAll();
            
        

    }});
    
    JPanel panelacciones = new JPanel();
    panelacciones.add(acciones);
    
           
    JPanel panelaccion = new JPanel();
    panelaccion.setBorder(BorderFactory.createTitledBorder("Action"));
    panelaccion.add(panelacciones);
    panelaccion.add(baccion);
    panelaccion.add(scroll2);
   
    //TERMINA ACCION
    //////
    
        btipo.setRequestFocusEnabled(false);
    btipo.addActionListener(new ActionListener(){
        public void actionPerformed (ActionEvent e){
            System.err.println("oso");
            String aux;
            aux = (String) tip2.getSelectedItem();
            System.err.println("oso11");
            if (aux.equals("CON_PERIOD")){
                System.err.println("oso1");
                eventoclase.removeAllItems();
                System.err.println("oso2");
            } else {
                System.err.println("oso3");
                eventoclase.removeAllItems();
                System.err.println("oso4");
                Enumeration enu = Onto.clases.elements();
                System.err.println("oso5");
                Clase cl;
                String nomb;
                while (enu.hasMoreElements()){
                    cl = (Clase) enu.nextElement();
                    nomb= cl.nombre;
                    eventoclase.addItem(nomb);
                }
            }

    }});
    
    
    
    ////////
    
    JPanel grid2 = new JPanel();
    grid2.setLayout(new GridLayout(3,1));
    grid2.add(panelevento);
    grid2.add(panelcondicion);
    grid2.add(panelaccion);
    
    JPanel contenedor = new JPanel();
    contenedor.setLayout(new GridLayout(3,1));
    //contenedor.add(nuevaregla);
    //contenedor.add(createregla);
    //contenedor.add(listaregla);
    
    contentPane.add(grid1,BorderLayout.NORTH);
    contentPane.add(grid2, BorderLayout.CENTER);
    contentPane.add(panelbotones, BorderLayout.SOUTH);
    
    dialog.show();
		
}//cerrar el metodo editregla
   */
        
        
 public void editregla(Frame frame, final String compra, final Control controlador, final Ontologia Onto) {
		
		contador=0;
		final Frame fa = frame;
		
		final JDialog dialog = new JDialog(frame, " Edit Rule", true);
		final JTextField eNombre;
		
		eNombre = new JTextField();
                eNombre.setText(compra);
                final JTextField impor = new JTextField();
		JTextField seleccion = new JTextField();
                final JComboBox eventoclase = new JComboBox();
                final JComboBox eventoslo = new JComboBox();
                final JComboBox eventoins = new JComboBox();
                
                valido = 0;
                final String nombreoriginal;
                nombreoriginal= compra;
                
                final JComboBox tip2 = new JComboBox();
                
		Container contentPane = dialog.getContentPane();
		
		dialog.setBounds(frame.getLocationOnScreen().x+100,frame.getLocationOnScreen().y+100,700,700);


                               
		JPanel panelbotones = new JPanel();
		JButton bAceptar = new JButton(" Accept ");
		JButton bCancel = new JButton(" Cancel ");
		
		bAceptar.setRequestFocusEnabled(false);
		bAceptar.addActionListener( new ActionListener() {
			    public void actionPerformed(ActionEvent e) {
                                
                                 nombre=eNombre.getText();
                                 id = nombre;
                                 if (nombreoriginal.equals(nombre)) {
                                    valido = 0;
                                 }else {
                                    valido = 1;
                                 }
			    	 	//valido=1;  
                                    if (eNombre.getText().length()==0) {
                                        Mensaje nuevo = new Mensaje(fa,"Error","Name invalid");
                                        return;				        	
                                    }
                                    String aux = (String) eventoins.getSelectedItem();
                                    String aux1 = (String) eventoslo.getSelectedItem();
                                    String aux3 = (String) tip2.getSelectedItem();
                                    if (aux3.equals("CON_PERIOD")){
                                        
                                    }else {
                                        if ((aux1 == null) || (aux == null)){
                                            Mensaje nuevo = new Mensaje(fa,"Aviso","Intancia o slot tienen puntero vacio");
                                            return;
                                        }
                                    }
                                 /*
                                    String ii = (String) eventoins.getSelectedItem();
                                        instancia = ii;
                                        String ss = (String) eventoslo.getSelectedItem();
                                        slote = ss;
                                 */
                                    if (impor.getText().length()==0) {
                                        numero = "0";                                        				        	
                                    }else {
                                        numero = impor.getText();
                                    }
                                                                  
                                    String aux4 = (String) tip2.getSelectedItem();
                                    if (aux4.equals("CON_PERIOD")){
                                        eventu.tipo = "CON_PERIOD";
                                        eventu.slote = " ";
                                    }else {
                                        
                                        eventu.tipo = aux4;
                                        String cc = (String) eventoclase.getSelectedItem();
                                        clase = cc;
                                        String ii = (String) eventoins.getSelectedItem();
                                        instancia = ii;
                                        String ss = (String) eventoslo.getSelectedItem();
                                        slote = ss;
                                        eventu.slote = cc+"."+ii+"."+ss;
                                    }
                                    //int i=0;
                                    condition.removeAllElements();
                                    int i = 0;
                                    while (i < 15){

                                       String palabra = (String) table.getValueAt(i,0);
                                       if (palabra.length() != 0){
                                           condition.add(palabra);
                                           
                                       }
                                       i++;
                                    }
                                    
                                    action.removeAllElements();
                                    i = 0;
                                    while (i < 15){

                                       String palabra = (String) table2.getValueAt(i,0);
                                       if (palabra.length() != 0){
                                           action.add(palabra);
                                           
                                       }
                                       i++;
                                    }
                                    
                                    
                                    		
				dialog.dispose();
				}});

        bCancel.setRequestFocusEnabled(false);
	bCancel.addActionListener( new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                dialog.dispose();
	}});

    panelbotones.add(bAceptar);
    panelbotones.add(bCancel);   
    panelbotones.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
    
       
    eNombre.setColumns(20);
    JPanel panelnom = new JPanel();
    panelnom.setBorder (BorderFactory.createTitledBorder("Name"));
    panelnom.add(eNombre);
    
    if (numero != null){
        impor.setText(numero);
    }
    impor.setColumns(5);
    JPanel panelimpor = new JPanel();
    panelimpor.setBorder (BorderFactory.createTitledBorder("Importance"));
    panelimpor.add(impor);
    
    JPanel grid1 = new JPanel();
    grid1.setLayout(new GridLayout(1,2));
    grid1.add(panelnom);
    grid1.add(panelimpor);
    
    
    //COMIENZA EVENTO
    
    //JLabel tip = new JLabel("Type");
    
    tip2.addItem("MODIFICATION");
    tip2.addItem("CON_PERIOD");
    tip2.addItem("DELETION");
    tip2.addItem("NEW_PRED");
    tip2.addItem("MATCHED_PRED");
    tip2.addItem("UNMATCHED_PRED");
   

    JButton btipo = new JButton ( "Ok");
    btipo.setRequestFocusEnabled(false);
    btipo.addActionListener(new ActionListener(){
        public void actionPerformed (ActionEvent e){
            String aux;
            aux = (String) tip2.getSelectedItem();
            if (aux.equals("CON_PERIOD")){
                eventoclase.removeAllItems();
            } else {
                eventoclase.removeAllItems();
                Enumeration enu = Onto.clases.elements();
                Clase cl;
                String nomb;
                while (enu.hasMoreElements()){
                    cl = (Clase) enu.nextElement();
                    nomb= cl.nombre;
                    eventoclase.addItem(nomb);
                }
                eventoclase.addItem("Metaclass");                
            }

    }});
    JPanel eventoarriba = new JPanel();
    eventoarriba.setBorder(BorderFactory.createTitledBorder("Type"));
    eventoarriba.add(tip2);
    eventoarriba.add(btipo);
    
    //El panel con la seleccion final
    seleccion.setColumns(20);
    JPanel panelseleccion = new JPanel();
    panelseleccion.setBorder (BorderFactory.createTitledBorder("Class_Instance_Slot"));
    panelseleccion.add(seleccion);
    
    //El panel que lleva Slot.slot
    JButton beventoslo = new JButton ( "Ok");
    beventoslo.setRequestFocusEnabled(false);
    beventoslo.addActionListener(new ActionListener(){
        public void actionPerformed (ActionEvent e){

    }});
    
    JPanel peventoslo = new JPanel();
    peventoslo.setBorder(BorderFactory.createTitledBorder("Slot"));
    peventoslo.add(eventoslo);
    peventoslo.add(beventoslo);
        
    
    //El panel que lleva Slot.instancia
    
    JButton beventoins = new JButton ( "Ok");
    beventoins.setRequestFocusEnabled(false);
    beventoins.addActionListener(new ActionListener(){
        public void actionPerformed (ActionEvent e){

            String cl = (String) eventoins.getSelectedItem();
            Instancia aux = new Instancia();
            Instancia encontrada = aux.BuscaInstancia(cl,Onto);
            
            
            int j = eventoslo.getItemCount(); 
            if (j != 0){
                eventoslo.removeAllItems();                
            }
            if (cl.equals("Instancia_Metaclass")){
                
                eventoslo.addItem("maxQuality");
                eventoslo.addItem("slsPolicy");
                eventoslo.addItem("reactivityDegree");
                eventoslo.addItem("eventRate");
                eventoslo.addItem("nCurrentBehavior");
                
            }else {
                String cla = encontrada.clase;
                Clase aux2 = new Clase();
                Clase encon=aux2.BuscaClase(cla, Onto);
                
                Enumeration en = encon.slots.elements();
                Slot slo = new Slot();
                String sloname;
                    while (en.hasMoreElements()){
                        slo = (Slot) en.nextElement();
                        sloname= slo.nombre;
                        eventoslo.addItem(sloname);
                    }
            }
            
            
            
    }});
    
    JPanel peventoins = new JPanel();
    peventoins.setBorder(BorderFactory.createTitledBorder("Instances"));
    peventoins.add(eventoins);
    peventoins.add(beventoins);
    
       
    //El panel que lleva Slot.clase
    JButton beventoclase = new JButton ( "Ok");
    beventoclase.setRequestFocusEnabled(false);
    beventoclase.addActionListener(new ActionListener(){
        public void actionPerformed (ActionEvent e){
            
            String cl = (String) eventoclase.getSelectedItem();
            Clase aux = new Clase();
            Clase encontrada = aux.BuscaClase(cl,Onto);
            
            if (cl.equals("Metaclass")){
                eventoins.addItem("Instancia_Metaclass");
            }else {
                Enumeration en = encontrada.instancias.elements();
            
                int talla = encontrada.instancias.size();
                int j = eventoins.getItemCount(); 
                if (j != 0){
                    eventoins.removeAllItems();                
                }

                Instancia ina = new Instancia();
                String intaname;
                    while (en.hasMoreElements()){
                        ina = (Instancia) en.nextElement();
                        intaname= ina.nombre;
                        eventoins.addItem(intaname);
                    }
            }
            
            
            
    }});
    //JComboBox eventoclase = new JComboBox();
    Enumeration enu = Onto.clases.elements();
    Clase cl;
    String nomb;
    while (enu.hasMoreElements()){
        cl = (Clase) enu.nextElement();
        nomb= cl.nombre;
        eventoclase.addItem(nomb);
    }
    eventoclase.addItem("Metaclass");
    
    JPanel peventoclase = new JPanel();
    peventoclase.setBorder(BorderFactory.createTitledBorder("Class"));
    peventoclase.add(eventoclase);
    peventoclase.add(beventoclase);
    
    
    //El gridlayout dondo meto el tipo , y los slot de clase, instancia y slot
    /*
    JPanel gridevent = new JPanel();
    gridevent.setLayout(new GridLayout(5,1));
    gridevent.add(eventoarriba);
    gridevent.add(peventoclase);
    gridevent.add(peventoins);
    gridevent.add(peventoslo);
    gridevent.add(panelseleccion);
    */
    
    if (eventu.tipo != null){
        String aux = eventu.tipo;
        tip2.setSelectedItem(aux);
        if (aux.equals("CON_PERIOD")){
            eventoclase.removeAllItems();
        }else{
            String aux2 = clase;
            eventoclase.setSelectedItem(aux2);
            eventoins.addItem(instancia);
            eventoslo.addItem(slote);
        }
     }
    
    
    JPanel vacio = new JPanel();
    JPanel vacio2 = new JPanel();
    JPanel gridevent = new JPanel();
    gridevent.setLayout(new GridLayout(2,3));
    gridevent.add(eventoarriba);
    gridevent.add(vacio);
    gridevent.add(vacio2);
    gridevent.add(peventoclase);
    gridevent.add(peventoins);
    gridevent.add(peventoslo);
    //gridevent.add(panelseleccion);
    
    //El gridlayout anterior todo rebordeado de la palabra evento
    JPanel panelevento = new JPanel();
    panelevento.setBorder(BorderFactory.createTitledBorder("Event"));
    panelevento.add(gridevent);
    
    //ACABA EVENTO
    
    
    //EMPIEZA CONDICION
    
    String[] columnNames = {" Conditions " };                        
    Object[][] data = {
                  
    		{""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""}
                   		
    };
    table = new JTable(data, columnNames);
    if (condition.size() != 0){
        int i = 0;
        int colum = 0;
        String elemento;
        Enumeration a = condition.elements();
        while (a.hasMoreElements()){
            elemento = (String) a.nextElement();
            table.setValueAt(elemento,i,colum);
            i++;
            
        }
    }    
    
    JScrollPane scrollpane = new JScrollPane (table);
    table.setPreferredScrollableViewportSize ( new Dimension(350,120));
    table.setShowHorizontalLines(true);

    JPanel scroll = new JPanel();
    scroll.add(scrollpane);
 
    
    JPanel vacio3 = new JPanel();
    
    JPanel gridcondi = new JPanel();
    gridcondi.setLayout(new GridLayout(1,2));
    gridcondi.add(scroll);
    gridcondi.add(vacio3);
    JPanel panelcondicion = new JPanel();
    panelcondicion.setBorder(BorderFactory.createTitledBorder("Condition"));
    //panelcondicion.add(gridcondi);
    panelcondicion.add(scroll);
    
    //ACABA CONDICION
    
    
    //EMPIEZA ACCION
        
    String[] columnNames2 = {" Actions " };                        
    Object[][] data2 = {
                  
    		{""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""}
                   		
    };
    table2 = new JTable(data2, columnNames2);
    if (action.size() != 0){
        int i = 0;
        int colum = 0;
        String elemento;
        Enumeration a = action.elements();
        while (a.hasMoreElements()){
            elemento = (String) a.nextElement();
            table2.setValueAt(elemento,i,colum);
            i++;
            
        }
    }    
    
    JScrollPane scrollpane2 = new JScrollPane (table2);
    table2.setPreferredScrollableViewportSize ( new Dimension(350,120));
    table2.setShowHorizontalLines(true);

    final JPanel scroll2 = new JPanel();
    scroll2.add(scrollpane2);
    
    final JComboBox acciones = new JComboBox();
    acciones.addItem("KDM_Set_Value 0 0 ");
    acciones.addItem("TriggerSporadicLevel 0 ");
    acciones.addItem("SetReactivityDegree 0 ");
    acciones.addItem("SetPolicy 0 ");
    acciones.addItem("SetFocus 0 0 ");
    acciones.addItem("SetAttentionDegree 0 ");
    acciones.addItem("SetBehavior 0 ");
    acciones.addItem("KDM_Add_Event 0 0 0 ");
    acciones.addItem("KDM_Release_Event 0 0 ");
    acciones.addItem("FunctionCall 0 ");
    acciones.addItem("Trigger_Optional 0.0");
    
    
    JButton baccion = new JButton ( "Add Action");
    baccion.setRequestFocusEnabled(false);
    baccion.addActionListener(new ActionListener(){
        public void actionPerformed (ActionEvent e){
            //table2.SetValueAt("a",contador,0);
            
            String auxi;
            auxi = (String) acciones.getSelectedItem();
            action.add(auxi);
            int colum= 0;
            int contador2 = action.size();
            table2.setValueAt(auxi,contador2-1,colum);
            contador=contador+1;
            
            //scroll2.removeAll();
            
        

    }});
    
    JPanel panelacciones = new JPanel();
    panelacciones.add(acciones);
    
           
    JPanel panelaccion = new JPanel();
    panelaccion.setBorder(BorderFactory.createTitledBorder("Action"));
    panelaccion.add(panelacciones);
    panelaccion.add(baccion);
    panelaccion.add(scroll2);
   
    //TERMINA ACCION
    
    
    JPanel grid2 = new JPanel();
    grid2.setLayout(new GridLayout(3,1));
    grid2.add(panelevento);
    grid2.add(panelcondicion);
    grid2.add(panelaccion);
    
    JPanel contenedor = new JPanel();
    contenedor.setLayout(new GridLayout(3,1));
    //contenedor.add(nuevaregla);
    //contenedor.add(createregla);
    //contenedor.add(listaregla);
    
    contentPane.add(grid1,BorderLayout.NORTH);
    contentPane.add(grid2, BorderLayout.CENTER);
    contentPane.add(panelbotones, BorderLayout.SOUTH);
    
    dialog.show();
		
}//cerrar el metodo editregla
        
        
        
        
        
    
    public JTable repintaraccion(JPanel panel) {
        
        String[] columnNames2 = {" Actions " };                        
        Object[][] data2 = {
                  
    		{""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""},
                {""}
                   		
        };
        table2 = new JTable(data2, columnNames2);
        int colum = 0;
        int siguiente = 0;
        String accion;
        Enumeration a = action.elements();
        while(a.hasMoreElements()){
            accion = (String) a.nextElement();
            table2.setValueAt(accion,siguiente,colum);
            siguiente = siguiente +1;
        }
       return table2; 
    } //termina el metodo .......
    
    
    
    
    
     public void aadirRegla(Frame frame, final Control co, final DefaultMutableTreeNode nodo, final DefaultTreeModel model, final JTree arbol){
     		
        //final Frame fa = frame;
        final Frame fa= new Frame();

        final JDialog dialogo = new JDialog(fa, " Add a new Rule", true);
        final JTextField eNombre;

        eNombre = new JTextField();

        Container contentPane = dialogo.getContentPane();

        dialogo.setBounds(frame.getLocationOnScreen().x+100,frame.getLocationOnScreen().y+100,350,250);
        
        valido = 0;
        
        final JTextField nreg = new JTextField();
        nreg.setColumns(20);
        JButton addreg = new JButton ( "Add rule");
        addreg.setRequestFocusEnabled(false);
        addreg.addActionListener(new ActionListener(){
            public void actionPerformed (ActionEvent e){
                if (nreg.getText().length()==0) {
                      Mensaje nuevo = new Mensaje(fa,"Error","Name invalid");
                    return;				        	
                } 
                valido = 2;
                nombre = nreg.getText();
                Enumeration a = co.reglas.elements();
                int cont = 0;
                while (a.hasMoreElements()) {
                        a.nextElement();
                        cont++;
                }
                cont++;

                id = nombre; 

                DefaultMutableTreeNode nuevo = new DefaultMutableTreeNode(nombre);
                int hijos;
                hijos = nodo.getChildCount();
                model.insertNodeInto(nuevo,nodo,hijos);
                TreeNode[] nodes = model.getPathToRoot(nuevo);
                TreePath path = new TreePath(nodes);
                arbol.scrollPathToVisible(path); 

                dialogo.dispose();



            }});
        JPanel nuevaregla = new JPanel();
        nuevaregla.setBorder(BorderFactory.createTitledBorder("Add New Rule"));
        nuevaregla.add(nreg);
        nuevaregla.add(addreg);

        ///////

        final JComboBox creg = new JComboBox();

        Enumeration a = co.reglas.elements();
        Regla elemento;
        String nom;
        while (a.hasMoreElements()){
            elemento = (Regla) a.nextElement();
            nom= elemento.nombre;
            creg.addItem(nom);
        }

        JButton createreg = new JButton ( "Add rule");
        createreg.setRequestFocusEnabled(false);
        createreg.addActionListener(new ActionListener(){
            public void actionPerformed (ActionEvent e){
                
                valido = 1;
                nombre = (String) creg.getSelectedItem();
                dialogo.dispose();
                
            }});
        JPanel createregla = new JPanel();
        createregla.setBorder(BorderFactory.createTitledBorder("Choose Rule"));
        createregla.add(creg);
        createregla.add(createreg);

        /////////
        
        JPanel panelbotones = new JPanel();
        JButton bAceptar = new JButton(" Accept ");
        JButton bCancel = new JButton(" Cancel ");

        bAceptar.setRequestFocusEnabled(false);
        bAceptar.addActionListener( new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                            if (valido == 0){
                                //dialogo.dispose();
                                Mensaje ne = new Mensaje(fa,"Error","Add Rule");
                                return;
                            }
                            if (valido ==1 ){
                               nombre = (String) creg.getSelectedItem();
                               dialogo.dispose();
                            }
                            if (valido == 2){
                               nombre = nreg.getText();
                               Enumeration a = co.reglas.elements();
                                int cont = 0;
                                while (a.hasMoreElements()) {
                                        a.nextElement();
                                        cont++;
                                }
                                cont++;

                                id = nombre; 

                                DefaultMutableTreeNode nuevo = new DefaultMutableTreeNode(nombre);
                                int hijos;
                                hijos = nodo.getChildCount();
                                model.insertNodeInto(nuevo,nodo,hijos);
                                TreeNode[] nodes = model.getPathToRoot(nuevo);
                                TreePath path = new TreePath(nodes);
                                arbol.scrollPathToVisible(path); 
                                
                                dialogo.dispose();
                                
                            }
                        }});

        bCancel.setRequestFocusEnabled(false);
	bCancel.addActionListener( new ActionListener() {
	    public void actionPerformed(ActionEvent e) {
                  valido = 0;
	   	  dialogo.dispose();
        }});

    //panelbotones.add(bAceptar);
    panelbotones.add(bCancel);   
    panelbotones.setBorder(BorderFactory.createEmptyBorder(10,10,10,10));
    

    
    eNombre.setColumns(20);
    JPanel panelnom = new JPanel();
    panelnom.setBorder (BorderFactory.createTitledBorder("Name"));
    panelnom.add(eNombre);
    
    //contentPane.add(panelnom, BorderLayout.CENTER);
    contentPane.add(nuevaregla, BorderLayout.NORTH);
    contentPane.add(createregla, BorderLayout.CENTER);
    contentPane.add(panelbotones, BorderLayout.SOUTH);
    
    dialogo.show();
     
 }//termina el metodo aadirRegla
     
     	public Regla BuscaRegla (String nombreb, Control con){
		
		Enumeration a = con.reglas.elements();
		int validar;
		validar = 0;
		Regla bes;
		Regla encontrado = new Regla();
		
		while (a.hasMoreElements()) {
			bes = (Regla) a.nextElement();
			if (nombreb.equals(bes.nombre)) {
				validar=1;
				encontrado=bes;
			}
		}
		
		if (validar==0) {
			return null;
		} else {
			return encontrado;
		}
		
	}//cierra el metodo BuscaRegla
        
        
    

	
	
} //termina la clase Regla